SystemOrganization addCategory: #AMMStudio!
SystemOrganization addCategory: #'AMMStudio-Example'!
SystemOrganization addCategory: #'AMMStudio-Test'!
SystemOrganization addCategory: #'AMMStudio-Units'!
SystemOrganization addCategory: #'AMMStudio-Widgets'!

NCEllipseMorph subclass: #AMMObjectNode
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.212'!
defaultBorderWidth 

	^ 3! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:13:04.64'!
defaultHeight 

	^ 30
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:12:58.993'!
defaultWidth

	^ 30
	
! !

!AMMObjectNode class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.232'!
newFor: anObject
	| node|
	
	node := self new.
	node object: anObject.
	
	^ node! !

!AMMObjectNode methodsFor: 'event handling' stamp: 'sw 5/27/2013 11:17:38.637'!
click

	self object toggleState.
	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:26:22.19'!
connectedNodes

	| nodes |
	nodes := OrderedCollection new.
	
	self connectedConstraints do: [ :ownConstraint | 
			| connectorMorph foreignConstraint | 
		connectorMorph := ownConstraint owner.
		foreignConstraint := connectorMorph constraints detect: 
			[:constrain | (constrain = ownConstraint) not].
		foreignConstraint inputs do: [ :node |
			nodes add: node
			]
	].

	^ nodes! !

!AMMObjectNode methodsFor: 'initialization' stamp: 'sw 5/27/2013 10:49:54.998'!
initialize 

	super initialize.

	self color: Color white.
	self borderWidth: self class defaultBorderWidth.
	self removeAllMorphs.
	self height: self class defaultHeight.
	self width: self class defaultWidth.
	
	self on: #click send: #click to: self.
	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:32:57.198'!
object

	^ object! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:15:11.027'!
object: anObject

	object := anObject.
	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 08:40:10.394'!
refresh 

	self setColor.! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:39:43.918'!
removeConnectorToNode: aNode

	self connectedConstraints do: [ :ownConstraint | 
		| connectorMorph foreignConstraint | 
		connectorMorph := ownConstraint owner.
		foreignConstraint := connectorMorph constraints detect: 
			[:constrain | (constrain = ownConstraint) not].
		foreignConstraint inputs do: [ :node |
			(node = aNode)
				ifTrue: [ 
					connectorMorph delete. 
					^ self
				].
			]
		].	! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 16:16:10.845'!
removeUnreferencedConnectors 

	self connectedNodes do:[ :connectedNode |
		((self object references includes: connectedNode object) or:
		( connectedNode object references includes: self object))
			ifFalse: [ self removeConnectorToNode: connectedNode ]
	
	].! !

!AMMObjectNode methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 23:28:31.129'!
setColor 

	(self object isRoot)
		ifTrue: [ self borderColor: Color red ]
		ifFalse: [ self borderColor: Color black ].
			
	(self object state = #marked) 
		ifTrue: [ self color: Color green ]
		ifFalse: [ 
			((self object state = #active) or: (self object flag = #activeTraversal)) 
				ifTrue: [ self color: Color yellow ]
				ifFalse: [ 
					(self object flag = #doneTraversal)
						ifTrue: [self color: Color lightGreen ]
						ifFalse: [self color: Color white ].					
					] 
			].! !

UiTextEditor subclass: #AMMSourceCodeEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMSourceCodeEditor class methodsFor: 'keyboard shortcut tables' stamp: 'sw 6/1/2013 10:52:44.959'!
initializeCmdKeyShortcuts

	super initializeCmdKeyShortcuts.
		
	cmdActions at: $o asciiValue + 1 put: #openIt:! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.897'!
browseIt

	| aSymbol |
	self lineSelectAndEmptyCheck: [^ self].
	(aSymbol := self selectedSymbol) == nil ifTrue: [^ morph flash].
	morph requestQuery: ((Smalltalk at: aSymbol
		ifAbsent: [^ morph requestImplementors: aSymbol])).! !

!AMMSourceCodeEditor methodsFor: 'actions' stamp: 'sw 6/1/2013 11:24:14.164'!
doIt: aKeyboardEvent
	
	self doIt.
	^ true.
! !

!AMMSourceCodeEditor methodsFor: 'do-its' stamp: 'sw 6/1/2013 10:52:44.937'!
evaluateSelectionAndDo: aBlock

	| result |
	result := super evaluateSelectionAndDo: aBlock.
	morph expressionEvaluated: result.  
	^ result  ! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.905'!
exploreIt
	self evaluateSelectionAndDo: [:result | morph requestExplorer: result]! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.912'!
implementorsOfIt

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ morph flash].
	morph requestImplementors: aSelector.  ! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.919'!
inspectIt
	self evaluateSelectionAndDo: [:result | morph requestExplorer: result]! !

!AMMSourceCodeEditor methodsFor: 'actions' stamp: 'sw 6/1/2013 10:52:44.945'!
openIt

	self lineSelectAndEmptyCheck: [^ self].
	
	self selectedSymbol ifNotNil: [:symbol |
		^ morph editView activateSymbol: symbol].
	self selectedSelector ifNotNil: [:symbol |
		^ morph editView activateSymbol: symbol].

	"self evaluateSelection ifNotNil: [:result |
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifFalse: [^ model activateObject: result]]."
	
	^ morph flash! !

!AMMSourceCodeEditor methodsFor: 'actions' stamp: 'sw 6/1/2013 10:52:44.953'!
openIt: aKeyboardEvent
	"Open code."

	self openIt.
	^ true! !

!AMMSourceCodeEditor methodsFor: 'menu messages' stamp: 'sw 6/1/2013 10:52:44.928'!
sendersOfIt

	| aSelector |
	self lineSelectAndEmptyCheck: [^ self].
	(aSelector := self selectedSelector) == nil ifTrue: [^ morph flash].
	morph requestSenders: aSelector.  ! !

!AMMSourceCodeEditor methodsFor: 'signals' stamp: 'sw 6/1/2013 15:00:04.932'!
sourceCodeExecuted

	self emit! !

!AMMSourceCodeEditor methodsFor: 'signals' stamp: 'sw 6/2/2013 20:42:56.212'!
sourceCodeExecuted: withResult
	self halt.
	self emit! !

UiTextEditor subclass: #AMMTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextEditor methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:59:06.57'!
doIt: anEvent

	self morph editView doIt.
	^ true! !

UiTestCase subclass: #AMMObjectGraphTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:47:56.734'!
setUp 
	super setUp.
	sut objects: OrderedCollection new.! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:03:38.691'!
subjectClass

	^ AMMObjectGraph! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:06:11.201'!
testANewObjectGraphHasNoNodes

	self assert: sut objectNodes size == 0.
	self assert: sut submorphs size == 0.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:47:03.565'!
testRenderingCreatesObjectNodes
	
	sut objects add: (AMMMetaObject for: AMMMetaObjectSimpleExample new).
	self assert: sut objectNodes isEmpty.
	sut render.
	self deny: sut objectNodes isEmpty.
	! !

!AMMObjectGraphTest methodsFor: 'as yet unclassified' stamp: 'sw 6/6/2013 11:16:44.821'!
testRenderingPreservesObjects
	
	| adv objects sim |
	self assert: sut objects isEmpty.
	adv := AMMMetaObject for: AMMMetaObjectAdvancedExample new.
	sim := AMMMetaObject for: AMMMetaObjectSimpleExample new.
	adv object otherObject: sim object.
	objects := OrderedCollection new add: adv; add: sim; yourself.
	sut objects:  objects.
	
	self deny: sut objects isEmpty.
	sut render.
	self deny: sut objects isEmpty.	! !

PasteUpMorph subclass: #AMMGarbageCollector
	instanceVariableNames: 'algorithm status objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:36:13.685'!
algorithm

	^ algorithm! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/4/2013 00:36:11.809'!
algorithm: anObject

	anObject isAMMAlgorithm ifTrue: [
		Transcript show: ' Algorithm set in Garbage Collector '; cr.
	
		algorithm ifNotNil: [
			self disconnectSignal: #phaseFinished from: algorithm.
		].
	
		algorithm := anObject.
	
		algorithm ifNotNil: [
			self connect: self algorithm signal: #phaseFinished toSelector: #reactOnAlgorithmPhaseFinished.
		].
	
		self refresh.
	].
! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:35:27.426'!
disableAlgorithm

	self algorithm disable.
	self disablePlayControls.! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:34:57.272'!
disablePlayControls

	self emit! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:37:27.347'!
enableAlgorithm

	self algorithm enable.
	self enablePlayControls.! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/4/2013 01:08:12.865'!
initialize 

	| text |
	super initialize.
	
	self extent: (100@100).
	self color: Color red.
	text := StringMorph contents: 'Garbage Collector'.
	text fontName: 'Courier' size: 5.
	text position: (5@5).
	self addMorph: (text).! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/3/2013 15:12:39.438'!
objects

	^ objects! !

!AMMGarbageCollector methodsFor: 'accessing' stamp: 'sw 6/3/2013 15:12:39.441'!
objects: anObject

	objects := anObject! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:40:03.767'!
reactOnAlgorithmPhaseFinished

	self stopAutoplay.
	
	" do something "
! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 17:33:41.751'!
refresh
	
	self algorithm ifNil: [
		self status: #inactive.
		self color: Color red.
	].

	self algorithm ifNotNil: [
		(self algorithm isEnabled) 
			ifTrue: [
			self status: #active.
			self color: Color green.
		]
			ifFalse: [
			self status: #sleeping.
			self color: Color yellow.
		].
	].
! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 17:27:13.769'!
render
	
	self refresh.! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:40:34.212'!
startAutoplay

	self emit.
! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 17:28:20.022'!
status

	^ status! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 17:35:49.76'!
status: aStatus

	status := aStatus.
! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 17:07:58.594'!
step

	self algorithm ifNotNil: [
		self algorithm step.
	].! !

!AMMGarbageCollector methodsFor: 'as yet unclassified' stamp: 'rm 6/2/2013 16:40:22.32'!
stopAutoplay

	self emit.
! !

PasteUpMorph subclass: #AMMObjectsRepresentation
	instanceVariableNames: 'studio objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMObjectsRepresentation subclass: #AMMHeap
	instanceVariableNames: 'heapCollection reservedCells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeap class methodsFor: 'as yet unclassified' stamp: 'rm 6/4/2013 00:25:26.233'!
defaultSize
 
	^ 256! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/7/2013 09:32:08.752'!
cellIsReservable: aCell

	^ ((aCell object isNil) and: ((self reservedCells indexOf: aCell) = 0))! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:37:37.479'!
clear

! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:40:58.621'!
clearHeap

	" remove all submorphs and empty all dictionaries/ collections"

	self removeAllMorphs.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/4/2013 10:15:46.844'!
createCells: amountOfCells

	"create entries for all objects"

	1 to: amountOfCells do: [ :cellNumber | 
		| cell |
		"self halt."
		cell := AMMHeapCell withId: cellNumber.
		cell position: ( (AMMHeapCell defaultWidth *(cellNumber-1)+self left) @ self top).
		cell lock.
		self addMorph: cell.
		self heapCollection add: cell.
	].
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/7/2013 09:42:21.88'!
freeAddressForSize: aSize
	| reseveredCells |
	reseveredCells := OrderedCollection new.

	self heapCollection doWithIndex: [:cell :index | 
		((index + aSize) > self heapCollection size) ifTrue: [ ^ nil].  
		(self cellIsReservable: cell)
			ifTrue: [ 
				reseveredCells add: cell.
				(1 to: (aSize-1)) do:[:i | | otherCell |
					otherCell := self heapCollection at: (index + i).
					(self cellIsReservable: otherCell) ifTrue: [ reseveredCells add: otherCell ].
					].
				(reseveredCells size = aSize ) 
					ifTrue:  [ self reservedCells addAll: reseveredCells.
								^ index]
					ifFalse: [ reseveredCells removeAll ]
			]
		].
	^ nil
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 23:54:08.705'!
freeEmptiedCells

	self submorphs do: [ :cell |
		(self objects includes: cell object) 
			ifFalse: [ cell object: nil ]	
		]! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:44.341'!
heapCollection
	
	 ^ heapCollection ifNil: [ heapCollection := OrderedCollection new ]! !

!AMMHeap methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:47:45.901'!
heapCollection: anObject

	heapCollection := anObject! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 5/6/2013 10:10:59.241'!
heapSize

	^ self heapCollection size! !

!AMMHeap methodsFor: 'initialization' stamp: 'sw 6/3/2013 15:05:42.085'!
initialize 

	super initialize.
	
	self size: AMMHeap defaultSize.! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/7/2013 09:34:02.774'!
mapObjectsToHeap
	" iterates over objects and marks used heap cells "

	self objects do: [ :object |
			| cell |
			0 to: (object sizeOfObject - 1) do: [ :offset |
				(self heapCollection size >= (object address + offset)) ifTrue: [
					cell := self heapCollection at: (object address + offset). 
					cell object: object.
				]
			]
		].
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 5/28/2013 22:41:12.765'!
refresh

	self submorphs  
		do:[ :morph | morph refresh ].! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/7/2013 09:34:53.973'!
render

	self freeEmptiedCells.
	self mapObjectsToHeap.
	self refresh.
	self reservedCells removeAll.! !

!AMMHeap methodsFor: 'accessing' stamp: 'sw 6/7/2013 09:28:11.299'!
reservedCells

	^ reservedCells ifNil: [ reservedCells := OrderedCollection new ]! !

!AMMHeap methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 21:40:42.376'!
setAddressFor: metaObject

	| position |
	position := self freeAddressForSize: metaObject sizeOfObject.
	
	position ifNil: 
		[ ^ AMMHeapOutOfSpaceError signal: 'No space left for this object' ].
	metaObject address: position.
	! !

!AMMHeap methodsFor: 'rendering' stamp: 'sw 6/4/2013 10:15:02.428'!
size: aHeapSize

	self extent: ((AMMHeapCell defaultWidth * aHeapSize)@100);
		borderWidth: 0;
		color: Color transparent;
		heapCollection: OrderedCollection new.
		
	self clearHeap.
	self createCells: aHeapSize.
! !

AMMObjectsRepresentation subclass: #AMMObjectGraph
	instanceVariableNames: 'objectNodes layoutAlgorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:20:25.515'!
addNewNodes
"Create one ObjectNode for every new object and register the morph in the temporary storage"
| newObjects |
	newObjects := self objects select: [:obj | (self objectNodes includesKey: obj) not ] .

	newObjects do:[ :obj |
		|node|
				node := AMMObjectNode newFor: obj.
				node object state = #marked ifTrue: [ node color: Color green. ].	
				self objectNodes at: obj put: node.
				self addMorph: node.
		].

	^ newObjects
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 14:16:38.383'!
clear

	self layoutAlgorithm delete.
	self removeNodes.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:40:23.524'!
connectNode: node with: anotherNode

	| connection |
	connection := NCAAConnectorMorph fromMorph: node toMorph: anotherNode.
	connection makeForwardArrow.
	self addMorph: connection.
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:52:22.695'!
connectNodes

	self objectNodes keysAndValuesDo:[ :metaObject :node |
		node removeUnreferencedConnectors.

		metaObject references do: [ :referencedMetaObject |
			node connectedNodes 
				detect: [:otherNode | (otherNode object = referencedMetaObject) ]
				ifNone: [ self connectNode: node with: (self objectNodes at: referencedMetaObject) ].
		] 
	]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:10:01.767'!
connectNodes: anCollection

	anCollection 
		do:[ :node|
			self connectReferences: node. 
		]! !

!AMMObjectGraph methodsFor: 'submorphs-add/remove' stamp: 'sw 5/6/2013 19:48:36.428'!
delete

	self clear.
	super delete.! !

!AMMObjectGraph methodsFor: 'initialization' stamp: 'ci 5/13/2013 17:19:58.113'!
initialize 

	super initialize.
	self 
		extent: 400@400;
		color: Color transparent;
	 	borderWidth: 0.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 13:40:23.548'!
layoutAlgorithm

	^ layoutAlgorithm ifNil: [ layoutAlgorithm := AMMGraphLayoutAlgorithm new.]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 19:48:20.328'!
layoutNodes
	WorldState
		addDeferredUIMessage: 
[ self layoutAlgorithm layoutMorph: self]
! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 11:05:48.348'!
objectNodes

	^ objectNodes ifNil: [ objectNodes := Dictionary new.]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 15:10:37.767'!
refresh 

	self objectNodes do: [ :node |
		node refresh.
		].! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:02:13.946'!
removeNodes 

	self removeAllMorphs.
	self objectNodes keysDo: [:key | self objectNodes removeKey: key ]! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:49:50.223'!
removeNodesOfDeletedObjects
	"self halt."
	self objectNodes values do: [ :node |
		(self objects includes: node object) 
			ifFalse: [ node  delete ]	
		]
	! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/29/2013 09:50:17.337'!
render

	| newNodes |

	self removeNodesOfDeletedObjects.
	newNodes := self addNewNodes.
	"self connectNodes: newNodes."

	self connectNodes.

	self layoutNodes.
	self refresh.! !

!AMMObjectGraph methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 12:41:50.661'!
runGraph

	WorldState
		addDeferredUIMessage: [self layoutAlgorithm layoutMorph: self]
layoutNodes

	"move nodes"! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 10:00:57.498'!
clear
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'sw 6/4/2013 17:45:44.97'!
objects

	^ objects ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:07:21.553'!
objects: anObject

	self clear.

	objects := anObject.

	self render.! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/15/2013 10:07:40.779'!
refresh

	self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'as yet unclassified' stamp: 'sw 5/6/2013 09:46:42.197'!
render
	^ self subclassResponsibility ! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.769'!
studio

	^ studio! !

!AMMObjectsRepresentation methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:56:19.78'!
studio: anObject

	studio := anObject! !

RectangleMorph subclass: #AMMHeapCell
	instanceVariableNames: 'id object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 10:16:12.805'!
defaultWidth

	^ 3! !

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'rm 6/4/2013 00:32:10.946'!
emptyColor

	^ (Color r: 0.8 g: 0.8 b: 0.8)! !

!AMMHeapCell class methodsFor: 'as yet unclassified' stamp: 'rm 6/4/2013 00:31:37.074'!
withId: aNumber
	| cell |
	cell := self new.
	cell extent: (4 @ 100).
	cell color:  AMMHeapCell emptyColor.
	cell borderWidth: 1.
	cell id: aNumber.
	^ cell.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:22:06.905'!
id
	^ id.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:24:54.733'!
id: aNumber
	id := aNumber.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'ci 5/13/2013 17:56:37.144'!
object

	^ object! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:13:21.867'!
object: anObject

	object := anObject.

	self setColor.! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'sw 5/15/2013 10:16:17.794'!
refresh 

	self setColor.
	! !

!AMMHeapCell methodsFor: 'accessing' stamp: 'rm 6/4/2013 00:31:29.378'!
setColor
	
	(self object isNil) 
		ifTrue: [ self color: AMMHeapCell emptyColor. ] 
		ifFalse: [
			(self object state = #marked) 
				ifTrue: [ self color: Color green ]
				ifFalse: [ 
					((self object state = #active) or: (self object flag = #activeTraversal))
						ifTrue: [ self color: Color yellow ]
				ifFalse: [ 					
					(self object flag = #doneTraversal)
						ifTrue: [self color: Color lightGreen ]
						ifFalse: [ self color: Color blue ].					
					] 
					]
		]
	! !

UiTextEdit subclass: #AMMSourceCodeEdit
	instanceVariableNames: 'theClass autoCreateArtifacts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMSourceCodeEdit commentStamp: '<historical>' prior: 0!
This is a text edit to modify a method's source.!

!AMMSourceCodeEdit class methodsFor: 'testing' stamp: 'sw 6/1/2013 10:14:42.153'!
isWidgetClass

	^ true! !

!AMMSourceCodeEdit class methodsFor: 'accessing' stamp: 'sw 6/1/2013 12:29:23.309'!
widgetCategory

	^ 'Input Widgets'! !

!AMMSourceCodeEdit class methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.166'!
widgetClassIcon

	^ UiFugueIcons scriptCodeIcon! !

!AMMSourceCodeEdit class methodsFor: 'accessing' stamp: 'sw 6/1/2013 12:29:13.386'!
widgetClassName

	^ 'AMM Source Code Edit'! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.911'!
acceptChanges

	self readOnly
		ifTrue: [^ self].

	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	(self parse and: [self compile]) ifTrue: [
		"Play done animation."
		self autoAccept ifFalse: [  
			ViAnimatedImageMorph
				flyOutOn: self
				with: UiFugueIcons tickIcon].
		
		^ super acceptChanges].
		
	self grabKeyboard.! !

!AMMSourceCodeEdit methodsFor: 'actions - activation' stamp: 'sw 6/1/2013 10:14:41.948'!
activateObject: anObject

	self flag: #informationHiding. "mt: Shoud not decide if class here!!"
	anObject isBehavior
		ifTrue: [self artifactRequested: anObject].! !

!AMMSourceCodeEdit methodsFor: 'actions - activation' stamp: 'sw 6/1/2013 10:14:41.955'!
activateSymbol: aSymbol

	(Smalltalk at: aSymbol ifAbsent: []) ifNotNil: [:obj |
		^ self activateObject: obj].
	
	(SystemNavigation default allImplementorsOf: aSymbol)
		ifNotNil: [:refs | refs size == 1 ifTrue: [^ self artifactRequested: refs first]].
	
	^ self textMorph requestImplementors: aSymbol! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.963'!
artifactRequested: anObject

	self emitInOwnerChain.  ! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.004'!
autoCreateArtifacts

	^ autoCreateArtifacts ifNil: [autoCreateArtifacts := false]! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.013'!
autoCreateArtifacts: aBoolean

	autoCreateArtifacts := aBoolean.! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/1/2013 10:14:42.071'!
compile

	^ true! !

!AMMSourceCodeEdit methodsFor: 'drawing' stamp: 'sw 6/1/2013 10:14:42.1'!
drawOn: aCanvas

	| c |
	super drawOn: aCanvas.
	
	self hasKeyboard ifTrue: [c := self colorFocusBorder].
	
	c ifNotNil: [
			
		aCanvas
			line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
			line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
		aCanvas
			line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
			line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
		aCanvas
			frameRectangle: self innerBounds
			color: (c alpha: 0.8)].! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/2/2013 17:01:38.817'!
evaluate

	^ Compiler evaluate: self theText asString! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/2/2013 17:01:42.793'!
evaluateSelection

	^ self textMorph editor evaluateSelection! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.973'!
focusChanged: aGlobalRectangle

	self emitInOwnerChain.! !

!AMMSourceCodeEdit methodsFor: 'initialization' stamp: 'sw 6/1/2013 10:49:28.566'!
initialize
	
	super initialize.
	
	self textMorph
		font: Preferences standardCodeFont;
		styler: AMMTextStyler new;
		margins: (4@0 corner: 4@0).
	
	self connect: self textMorph signal: #focusChanged: toSelector: #onFocusChanged:.
	self connect: self textMorph signal: #repeatedReturnPressed: toSelector: #onRepeatedReturnPressed:.

	self connect: self eventHandler signal: #mouseWheelUp: toSelector: #mouseWheelUp:.
	self connect: self eventHandler signal: #mouseWheelDown: toSelector: #mouseWheelDown:.! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.984'!
mouseWheelDown: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].
		
	self emitInOwnerChain.! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.991'!
mouseWheelUp: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].

	self emitInOwnerChain.! !

!AMMSourceCodeEdit methodsFor: 'signals' stamp: 'sw 6/1/2013 10:14:41.998'!
newArtifactRequested

	self emitInOwnerChain.  ! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.923'!
onFocusChanged: aLocalRectangle
	"Mapping to global coordinates."
	
	self focusChanged: (self textMorph bounds: aLocalRectangle in: self world).! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.933'!
onRepeatedReturnPressed: count

	self autoCreateArtifacts ifFalse: [^ self].

	count == 2 ifTrue: [
		(UiMessage information: 'Tap once more for new object.')
			bottomLeft: (self textMorph localPointToGlobal: self textMorph editor pointBlock bottomLeft) - (0@5);
			openInWorld].
		
	count == 3 ifTrue: [
		self textMorph undoRepeatedReturnPress.
		self newArtifactRequested].! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.024'!
optimalWidth
	"Override to ignore comments."
	
	| maxWidth |
	maxWidth := 0.

	((self theText asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		copyReplaceAll: String tab with: '   ')
	   linesDo: [:line | 
			maxWidth := maxWidth max: (self textMorph textStyle defaultFont widthOfString: line)].
		
	^ maxWidth + self scrollBarThickness + 20 ! !

!AMMSourceCodeEdit methodsFor: 'evaluation' stamp: 'sw 6/1/2013 10:14:42.094'!
parse

	^ true! !

!AMMSourceCodeEdit methodsFor: 'actions' stamp: 'sw 6/1/2013 10:14:41.941'!
revertChanges

	self readOnly
		ifTrue: [^ self].
		
	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	super revertChanges.
	
	"Play done animation."
	ViAnimatedImageMorph
		flyOutOn: self
		with: UiFugueIcons crossIcon.! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.036'!
selectedSelector
	"If possible, return the selector that is behind the current selection."
	
	^ self textMorph editor selectedSelector! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.043'!
sourceCode

	^ self theText! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.05'!
sourceCode: someCode

	self theText: someCode.! !

!AMMSourceCodeEdit methodsFor: 'accessing - private' stamp: 'sw 6/1/2013 12:08:56.241'!
textModelClass

	^ AMMWorkspace! !

!AMMSourceCodeEdit methodsFor: 'accessing - private' stamp: 'sw 6/1/2013 10:48:03.983'!
textMorphClass

	^ AMMSourceCodeTextMorph! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.057'!
theClass

	^ theClass! !

!AMMSourceCodeEdit methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:14:42.063'!
theClass: aClassOrMetaClass

	theClass = aClassOrMetaClass ifTrue: [^ self].
	
	self flag: #merge. "mt: store reference only once; maybe in model"
	theClass := aClassOrMetaClass.
	self model theClass: theClass.
	
	self textMorph styler ifNil: [^ self].
	theClass ifNil: [^ self].
		
	theClass isMeta
		ifTrue: [self textMorph styler: ViTextStylerForClass new]
		ifFalse: [self textMorph styler: ViTextStyler new].
	
	self textMorph styler classOrMetaClass: theClass.! !

UiTextEdit subclass: #AMMTextEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 11:06:08.274'!
doIt

	self doIt: self selectedText asString.! !

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 11:00:30.778'!
doIt: aString

	self emit. ! !

!AMMTextEdit methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:51:45.23'!
textMorphClass

	^ AMMTextMorph! !

Workspace subclass: #AMMWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMWorkspace methodsFor: 'accessing' stamp: 'sw 6/1/2013 14:55:14.932'!
bindingOf: aString

	^ super bindingOf: aString! !

!AMMWorkspace methodsFor: 'accessing' stamp: 'sw 6/2/2013 19:36:20.407'!
bindings

	^ bindings! !

!AMMWorkspace methodsFor: 'accessing' stamp: 'sw 6/1/2013 14:35:20.637'!
bindings: someBindings

	self setBindings: someBindings.
	! !

!AMMWorkspace methodsFor: 'completion' stamp: 'sw 6/1/2013 14:27:05.395'!
createCompletionController
	
	^ OController model: self! !

Object subclass: #AMMApplication
	instanceVariableNames: 'metaObjects heap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:47:16.296'!
addMetaObject: aMetatObject 
	
	((self metaObjects indexOf: aMetatObject) > 0) ifTrue: [ self ].
	self heap setAddressFor: aMetatObject.
	self metaObjects add: aMetatObject.
	self connect: aMetatObject signal: #changed toSelector:#objectsChanged.
	aMetatObject references do: 
		[ :otherMetatObject | self addMetaObject: otherMetatObject ]
! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/7/2013 09:35:40.655'!
addObject: anObject

	anObject ifNil: [ ^ self errorOccured: 'nil cannot be added to objects']. 
	(self includesObject: anObject ) ifTrue: [ ^ self errorOccured: 'Objects cannot be added twice']. 
	
	[
		self addMetaObject: (AMMMetaObject for: anObject).
	] on: AMMHeapOutOfSpaceError do: [ self errorOccured: 'No space left for this insertion' ].
! !

!AMMApplication methodsFor: 'events-triggering' stamp: 'sw 6/4/2013 09:53:28.984'!
errorOccured: aMessage
	
	self emit! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/3/2013 20:17:23.286'!
heap

	^ heap! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/3/2013 20:17:23.289'!
heap: anObject

	heap := anObject! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:43:39.317'!
includesObject: anObject

	^ (self metaObjects detect: [:metaObject | metaObject object = anObject ] ifNone:[nil]) notNil 
	! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:43:15.353'!
metaObjects

	^ metaObjects ifNil: [metaObjects := OrderedCollection new]! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:44:53.923'!
objects 
	self halt.! !

!AMMApplication methodsFor: 'events-triggering' stamp: 'sw 6/3/2013 22:35:05.918'!
objectsChanged

	self emitAlways ! !

!AMMApplication methodsFor: 'events-triggering' stamp: 'sw 6/3/2013 14:58:07.328'!
setGCAlgorithm: anAlgorithm 

	self emitAlways! !

!AMMApplication methodsFor: 'accessing' stamp: 'sw 6/6/2013 13:43:49.388'!
setReachableObjectsAsRoot: boundObjects
	"When the the object in the binded objects (attached collection) the metaobject is a root. "

	self metaObjects do:[ :metaObject | | objectIsIncluded |
		objectIsIncluded := ((boundObjects indexOf: metaObject object) > 0).
		metaObject isRoot: objectIsIncluded.
		]! !

Object subclass: #AMMGCAlgorithm
	instanceVariableNames: 'phase objects objectStack currentObjectIndex enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 18:16:06.108'!
currentObjectFromMemory

	self objects ifNil: [ ^ nil].
	
	((self currentObjectIndex > 0) and: (self objects size >= self currentObjectIndex)) 
		ifTrue:  [ ^ self objects at: self currentObjectIndex ]
		ifFalse: [	 ^ nil ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:01:18.853'!
currentObjectIndex

	^ currentObjectIndex ifNil: [currentObjectIndex := 0 ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 18:01:47.427'!
currentObjectIndex: anObject

	currentObjectIndex := anObject! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:05:13.077'!
disable
	
	self enabled: false! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:04:57.779'!
enable

	self enabled: true! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:06:01.344'!
enabled

	^ enabled ifNil: [ enabled := true ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:04:29.537'!
enabled: anObject

	enabled := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:17:08.483'!
enter: anObject

	self objectStack at: anObject put: 0.
	anObject flag: #activeTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:37:39.093'!
findNextUntraversedRoot
	" returns first object which hasn't been traversed yet and is a root - therefore globally reachable "

	self objects 
		do:[ :obj | 
				(obj hasBeenTraversed = false and: ( obj isRoot)) 
					ifTrue: [ ^ obj ] 
			].
	^ nil
		! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:26:20.184'!
indexOfLastChildOf: anObject

	^ self objectStack at: anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 21:00:35.074'!
initialize

	super initialize.
	
	self disable.! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 6/3/2013 13:46:30.432'!
isAMMAlgorithm 

	^ true! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 21:03:26.472'!
isEnabled
	
	^ enabled == true! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:23:42.31'!
lastVisitedObject

	^ self objectStack orderedKeys last! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:19:54.82'!
leave: anObject

	self objectStack removeKey: anObject.
	anObject flag: #doneTraversal.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:32:24.811'!
nextChildOf: object
	| nextChild  index | 
	
	index := self indexOfLastChildOf: object.
	nextChild :=  object references at: (index +1) ifAbsent: nil.
	self objectStack at: object put:(index +1).

	^ nextChild! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:04:31.413'!
nextObject
| object |
	self objectStack isEmpty 
		ifTrue: [
		"no parent-object is on the stack"
			object := self findNextUntraversedRoot.
			(object isNil) 
				ifFalse: [ self enter: object ].
		] ifFalse: [
		
			object := self nextChildOf: self lastVisitedObject.			
			(object isNil)
				ifTrue: [ 
					" last reference of object was visited, we can leave the object now"
					self leave:  self lastVisitedObject. 
					object := self nextObject.
					] 
				ifFalse: [
					object hasBeenTraversed 
						ifTrue:  [ object := self nextObject.] 
						ifFalse: [ self enter: object ].			
					].
			].
		^ object
! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 23:31:02.822'!
nextPhase

	self phase: self phase+1.
	self currentObjectIndex: 0.
	self phaseFinished.! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:44:01.09'!
objectStack
	^ objectStack ifNil: [ objectStack := OrderedKeysIdentityDictionary new ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:32.47'!
objectStack: anObject

	objectStack := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:30.436'!
objects 
	^ objects! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 10:41:15.423'!
objects: anCollection
	objects := anCollection! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:41.905'!
phase

	^ phase ifNil: [ phase := 0 ]! !

!AMMGCAlgorithm methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:41:32.468'!
phase: anObject

	phase := anObject! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 10:13:15.262'!
phaseFinished

	self emit! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:11:40.486'!
reset
	self objects do: [ :obj | obj flag: #new ].
	self currentStage: #clearStates.
	self objectStack removeAll.
	! !

!AMMGCAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 23:39:20.527'!
step
	" executes the method regarding to the current phase of the alogrithm
	e.g. AMMGCAlgorithm >> phase01Starting
	"
	|method|
	
	self enabled ifFalse: [ ^ self ].

	method := self class methodDictionary keys 
		detect: [:methodName|
			(((methodName asString) findString: ('phase0', self phase)) > 0 ) ]
		ifNone: [ ^ self ].
		
	self perform: method.
	! !

AMMGCAlgorithm subclass: #AMMMarkAndSweap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:03:27.698'!
phase00ClearAllStates
	"clear all flags of the objects"
	
	| object lastObject |
	
	lastObject := self currentObjectFromMemory.
	lastObject ifNotNil: [ lastObject state: #inactive].
	
	self currentObjectIndex: self currentObjectIndex+1.
	
	object := self currentObjectFromMemory.
	(object isNil) 
		ifTrue:  [ self nextPhase ]
		ifFalse:  [ 
			object state: #active.
			object flag: #clear.
		].
	! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 22:42:09.262'!
phase01TraverseTree
	
	| object |

	object := self nextObject.

	object ifNil: [ self nextPhase. ].
! !

!AMMMarkAndSweap methodsFor: 'as yet unclassified' stamp: 'sw 5/28/2013 23:55:05.175'!
phase02RemoveUnusedObjects
	
	| object lastObject |
	
	lastObject := self currentObjectFromMemory.
	lastObject ifNotNil: [ lastObject state: #inactive].
	
	self currentObjectIndex: self currentObjectIndex+1.
	
	object := self currentObjectFromMemory.
	(object isNil) 
		ifTrue:  [ self nextPhase ]
		ifFalse:  [ 
			object state: #active.
			(object flag = #doneTraversal)
				ifFalse: [ 
					self objects remove: object. 
					self currentObjectIndex: self currentObjectIndex-1.
					object remove ]. 
		].! !

Object subclass: #AMMHuman
	instanceVariableNames: 'age father mother name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Example'!

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 12:48:57.059'!
age
	<size:4> 
	
	^ age! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.535'!
age: anObject

	age := anObject! !

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/7/2013 08:59:45.056'!
father
	<reference>
	
	^ father! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.552'!
father: anObject

	father := anObject! !

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/7/2013 08:59:49.404'!
mother
	<reference>
	
	^ mother! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.553'!
mother: anObject

	mother := anObject! !

!AMMHuman methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 12:59:05.955'!
name
	<size:80> " String of 20 characters encoded with unicode "
	
	^ name! !

!AMMHuman methodsFor: 'accessing' stamp: 'sw 6/7/2013 08:54:47.555'!
name: anObject

	name := anObject! !

Object subclass: #AMMMetaObject
	instanceVariableNames: 'address state flag isRoot object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMMetaObject class
	instanceVariableNames: 'objects'!

AMMMetaObject class
	instanceVariableNames: 'objects'!

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:29:07.015'!
for: anObject

	objects ifNil: [ objects := Dictionary new ].
	
	^ objects at: anObject ifAbsentPut: [ AMMMetaObject new object: anObject ]! !

!AMMMetaObject class methodsFor: 'as yet unclassified' stamp: 'sw 6/6/2013 13:50:41.303'!
reset
	
	objects := nil.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:47:02.404'!
address

	^ address! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'rm 5/6/2013 13:46:46.902'!
address: anAddress

	address := anAddress.! !

!AMMMetaObject methodsFor: 'event-handling' stamp: 'sw 5/15/2013 09:46:01.333'!
changed

	self emit.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:35:16.035'!
flag
	" is used for the garbage collection algorithms"
	^flag! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/28/2013 22:15:46.333'!
flag: aSymbol
	" is used for the garbage collection algorithms"
	flag := aSymbol.
	self changed.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 15:12:55.847'!
hasBeenTraversed

	^ (self flag == #doneTraversal) or: (self flag == #activeTraversal) ! !

!AMMMetaObject methodsFor: 'initialize-release' stamp: 'sw 5/15/2013 09:58:10.281'!
initialize 

	super initialize.

	self flag: #new.
	self isRoot: false.! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/4/2013 17:10:17.282'!
instanceVaribalesWithSize: anObject

	| classes vars |
	classes := self relevantclassesForClass: anObject class.

	vars := Dictionary new.
	anObject class allInstVarNames do: [:varName |
		vars at: varName put: nil.
		classes do:[:class | |compiledMethod |
			compiledMethod := class methodDictionary at: varName asSymbol  ifAbsent: [ nil ].
			compiledMethod ifNotNil:[
				(compiledMethod pragmaAt: #reference) isNil 
					ifTrue: [	vars at: varName put: ((compiledMethod pragmaAt: #size:) arguments at:1). ]
					ifFalse: [ vars at: varName put: 4 "if the slot is a reference, 32bit/4Byte is needed "]
			].
		].

	].

	^ vars
		! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.021'!
isRoot

	^ isRoot! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:36:05.027'!
isRoot: anObject

	isRoot := anObject! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/3/2013 20:05:36.8'!
object

	^ object! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:58:30.524'!
object: anObject

	(self objectIsUsable: anObject)
		ifTrue: [ object := anObject ] 
		ifFalse: [ AMMObjectIsNotExtended signal: 'Object cannot be used in this context - please extend all accessors with pragmas!!']
		! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/4/2013 17:10:36.795'!
objectIsUsable: anObject
	
	| vars |
	vars := self instanceVaribalesWithSize: anObject.
	
	vars keysAndValuesDo: [:varName :varSize | 
		varSize ifNil: [ ^ false]
		].
	
 	^ true! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/7/2013 09:11:57.666'!
references 

	| references |
	references := OrderedCollection new.
	self variablesNamesOfReferences do: [ :varName | | referencedObject |
		referencedObject := self object perform: (varName asSymbol).
		referencedObject ifNotNil:
			[references add: (AMMMetaObject for: referencedObject)].
		].
	
	^ references ! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/3/2013 23:12:37.394'!
relevantclassesForClass: aClass

	| classes |
	classes := OrderedCollection new.
	classes add: aClass.

	(aClass superclass = Object)
		ifFalse:  	[
			classes addAll: (self relevantclassesForClass: aClass superclass).
		].

	^ classes

! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/28/2013 23:43:44.509'!
remove
	
	self changed ! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/4/2013 17:08:39.783'!
sizeOfObject

	| instanceVariables size |
	instanceVariables := self instanceVaribalesWithSize: self object.
	size := 0 .
	instanceVariables valuesDo: [:variableSize | size := size + variableSize ].
	
	^ size! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/9/2013 12:34:17.707'!
state
	" is used for grafical representation "
	^ state! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/27/2013 17:58:42.479'!
state: aState
	" is used for graphical representation 
		-> #marked when somebody clicked on it
		-> #active when the algorithm is busy with it
		"

	state := aState.
	
	self changed.! !

!AMMMetaObject methodsFor: 'accessing' stamp: 'sw 5/15/2013 09:55:38.274'!
toggleState 

	(self state = #marked) 
		ifTrue: [
			self state: #unmarked.
		 ]
	 	ifFalse: [
			self state: #marked.
		].! !

!AMMMetaObject methodsFor: 'memory-management' stamp: 'sw 6/4/2013 17:31:14.236'!
variablesNamesOfReferences

	| variableNames classes |
	variableNames := OrderedCollection new.
	classes := self relevantclassesForClass: self object class.
	
	self object class allInstVarNames do: [:varName |
		classes do:[:class | |compiledMethod |
			compiledMethod := class methodDictionary at: varName asSymbol  ifAbsent: [ nil ].
			compiledMethod ifNotNil:[
				(compiledMethod pragmaAt: #reference) notNil 
					ifTrue: [	variableNames add: varName ]
			].
		].

	].
	^ variableNames ! !

Object subclass: #AMMMetaObjectAdvancedExample
	instanceVariableNames: 'otherObject localVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:19.523'!
localVariable
	<size:8>
	^ localVariable! !

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:12.149'!
localVariable: anObject

	localVariable := anObject! !

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:25.583'!
otherObject
	<reference>
	^ otherObject! !

!AMMMetaObjectAdvancedExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:40:12.145'!
otherObject: anObject

	otherObject := anObject! !

Object subclass: #AMMMetaObjectSimpleExample
	instanceVariableNames: 'var1 var2 var3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectSimpleExample methodsFor: 'as yet unclassified' stamp: 'sw 6/1/2013 13:51:21.965'!
var1
	<size: 10>! !

!AMMMetaObjectSimpleExample methodsFor: 'as yet unclassified' stamp: 'sw 6/1/2013 13:51:25.16'!
var2
	<size:11>! !

!AMMMetaObjectSimpleExample methodsFor: 'as yet unclassified' stamp: 'sw 6/1/2013 13:51:29.742'!
var3
	<size:13>! !

AMMMetaObjectSimpleExample subclass: #AMMMetaObjectSimpleSubExample
	instanceVariableNames: 'var4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectSimpleSubExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:46:01.128'!
var4
	<size:4>

	^ var4! !

!AMMMetaObjectSimpleSubExample methodsFor: 'accessing' stamp: 'sw 6/4/2013 16:45:53.337'!
var4: anObject

	var4 := anObject! !

Object subclass: #AMMMetaObjectUnextendedExample
	instanceVariableNames: 'var'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

Object subclass: #AMMSimpleBall
	instanceVariableNames: 'diameter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Example'!

AMMSimpleBall subclass: #AMMColoredBall
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Example'!

!AMMColoredBall methodsFor: 'accessing' stamp: 'sw 6/3/2013 22:44:10.398'!
color
	<reference>
	^ color! !

!AMMColoredBall methodsFor: 'accessing' stamp: 'sw 6/3/2013 22:44:03.554'!
color: anObject

	color := anObject! !

!AMMSimpleBall methodsFor: 'accessing' stamp: 'sw 6/3/2013 22:43:28.122'!
diameter
	<size:8>
	^ diameter! !

!AMMSimpleBall methodsFor: 'accessing' stamp: 'sw 6/3/2013 22:43:19.705'!
diameter: anObject

	diameter := anObject! !

Object subclass: #AMMUnit
	instanceVariableNames: 'currentSequence maxState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:57:49.277'!
heapSize

	self subclassResponsibility ! !

!AMMUnit class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:45:19.383'!
nameOfUnit

	self subclassResponsibility ! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 6/10/2013 10:24:35.161'!
currentSequence

	^ currentSequence ifNil: [ currentSequence := 0 ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 6/10/2013 10:22:13.117'!
currentSequence: anObject

	currentSequence := anObject! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:27:37.972'!
disableNextButton

	self emit.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/29/2013 08:31:38.83'!
disablePlayControls

	self emit! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:23:43.176'!
doOnce: aBlock

	(self currentSequence == maxState) 
		ifTrue: [ ^ aBlock value ]! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/27/2013 16:27:26.839'!
enableNextButton

	self emit.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/29/2013 08:31:36.978'!
enablePlayControls

	self emit! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/16/2013 11:11:33.487'!
finished
	
	self emit.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 6/4/2013 09:32:28.054'!
makeObjectReachable: anObject withLabel: aLabel

	self emit! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:20:23.657'!
maxState
	
	^ maxState ifNil: [ maxState := 0 ]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/27/2013 16:19:45.987'!
maxState: anObject

	maxState := anObject! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:23:50.345'!
next 

	self currentSequence: self currentSequence +1.
	self showSequence.! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:23:53.778'!
previous  

	(self currentSequence > 1)
		ifTrue: [
			self currentSequence: (self currentSequence -1).
			]
		ifFalse: [ 
			self currentSequence: 1.
			].
	self showSequence.! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:09:11.459'!
reactOnAlgorithmPhaseFinished

	self stopAutoplay.
	
	" do something "
! !

!AMMUnit methodsFor: 'event handling' stamp: 'rm 6/2/2013 17:40:14.009'!
setGCAlgorithm: anAlgorithm

	self emit.! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 5/16/2013 10:19:23.847'!
showMessage: aMessage

	self emit.! !

!AMMUnit methodsFor: 'unit-interaction' stamp: 'sw 6/10/2013 10:24:06.789'!
showSequence 

	| method |
	self enableNextButton.

	method := self class methodDictionary keys 
		detect: [:methodName|
			(self currentSequence >= 10)
				ifTrue: [
					(((methodName asString) findString: ('sequence', self currentSequence)) > 0 )
					]
				ifFalse: [
					(((methodName asString) findString: ('sequence0', self currentSequence)) > 0)
					]
				]
		ifNone: [ method:= #finished ].
		
	self perform: method.! !

!AMMUnit methodsFor: 'actions' stamp: 'sw 6/3/2013 13:37:58.939'!
sourceCodeActions

	| actions |
	actions := Dictionary new.
	
	^ actions
	! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 6/3/2013 13:36:58.246'!
sourceCodeExecuted: aSourceCode withBindings: aBindingsDictionary withResult: aResult

	self sourceCodeActions keysAndValuesDo: [ :sourceCode :methodName |
		( sourceCode match: aSourceCode )
			ifTrue: [ self perform: methodName with: aSourceCode with: aBindingsDictionary with: aResult ]
		]! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:11:03.757'!
startAutoplay

	self emit.
! !

!AMMUnit methodsFor: 'accessing' stamp: 'sw 5/28/2013 21:08:50.889'!
stopAutoplay

	self emit.
! !

!AMMUnit methodsFor: 'event handling' stamp: 'sw 6/4/2013 09:32:36.628'!
storeObjectInMemory: anObject

	self emit.! !

AMMUnit subclass: #AMMUnit0
	instanceVariableNames: 'pcI challengeAccomplished'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 10:33:47.112'!
heapSize 

	^ 40! !

!AMMUnit0 class methodsFor: 'as yet unclassified' stamp: 'sw 5/16/2013 10:50:11.957'!
nameOfUnit

	^ 'Welcome'! !

!AMMUnit0 methodsFor: 'accessing' stamp: 'sw 5/24/2013 13:04:42.248'!
initialize 

	super initialize.
	challengeAccomplished := false.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:54:12.931'!
sequence01Start 

	self showMessage:
'Hello you,
You can learn how the mark and sweep algorithm works here. 

Click on next to learn about this learning environment first!!!!'.
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 13:40:16.045'!
sequence02IntroduceElements
	
	self doOnce: [
		self fillInitialObjects.
		].
	
	self showMessage:
'You can see various elements here.
On the left side, you find the lecture-selector. Here you can choose a particular topic, you want to dive into.
Next to it, the stepping-menu is located. With this, you can control how algorithms are applied in later lectures. You can step through every single instruction or you can play it up automatically.

On the right hand side you can see the heap, which is the memory representation.
Under the heap, you see another way of representing objects: an object graph.

Click next to continue!!'.
! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:00.057'!
sequence03IntroduceInteractionWithNodes
	
	self doOnce: [
		self addObject: (AMMObject new size: 5 ; address: 37; yourself).
		challengeAccomplished := false.
		self disableNextButton.
		].
	self showMessage:
'Like everywhere, these objects change frequently. 
So, objects are added and removed from the program.
You will learn, which strategies are applied to remove the objects from the memories regardingly.

You can click on every node to see, where it is located in the heap. Try it!!

'.! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 13:04:40.784'!
sequence04IntroducePseudoCode
	
	self doOnce: [
		challengeAccomplished := false.
		self disableNextButton.
		].
	
	self showMessage:'This text-field is interactive!!

As everywhere in squeak, you can select text and execute the code.

Please try it!! Select one line of the following pseudo code and execute it!!

int := 0.
int := int + 2.'! !

!AMMUnit0 methodsFor: 'as yet unclassified' stamp: 'sw 5/27/2013 16:55:43.538'!
sequence05IntroduceUnits

	self showMessage:
'You can access many units here. As mentioned before, you can navigate to tehm directly via the lecture-selector.
Otherwise, you can follow our whole course an ... just click next. 
Your first lecture will start immediately.'.
! !

!AMMUnit0 methodsFor: 'actions' stamp: 'sw 6/3/2013 13:37:33.728'!
sourceCodeActions

	| actions |
	actions := Dictionary new.
	actions at: '*int := 0*' put: #variableCreatedWithSourceCode:withBindings:withResult:.
	
	^ actions
	! !

!AMMUnit0 methodsFor: 'actions' stamp: 'sw 6/3/2013 14:14:28.819'!
variableCreatedWithSourceCode: aSourceCode withBindings: aBinding withResult: aResult
	
	((aBinding at: #int) >= 2)
		ifTrue: [ self enableNextButton ].	! !

AMMUnit subclass: #AMMUnit1
	instanceVariableNames: 'nextFreeObjectAddresses john peter greta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 14:19:11.438'!
heapSize 

	^ 45! !

!AMMUnit1 class methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 11:44:55.082'!
nameOfUnit

	^ 'Unit #1'! !

!AMMUnit1 methodsFor: 'accessing' stamp: 'sw 6/10/2013 10:24:21.982'!
reactOnAlgorithmPhaseFinished

	super reactOnAlgorithmPhaseFinished.
	
	(self currentSequence == 9) 
		ifTrue: [
			self disableAlgorithm.
			self next.
			]. 
		
	(self currentSequence == 11) 
		ifTrue: [
			self algorithm disable.
			self next.
			]. 
	(self currentSequence == 14) 
		ifTrue: [
			self disableAlgorithm.
			self next.
			]. ! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:00:47.116'!
sequence01Start 

	self showMessage:
'Mark and Sweep is a two phase algorithm
During the first phase reachable objects are visited. 
Each visited object gets marked.
Referenced objects are visited recursively. If an object has been marked already, the recursion is cancelled.

During the second phace all unmarked objects are removed from the memory.'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:00:50.575'!
sequence02ExplainInitiationOfGC 

	self showMessage: 'Mark and sweep is a start-stop algorithm. Therefore the user program is interrupted for the garbage collection. 
	
The garbage collection is started when not enough space is left for a required memory allocation.'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 6/3/2013 14:19:26.867'!
sequence03InitiateGC 
	
	self doOnce: [ self disableNextButton ].
	self showMessage: 'Ok, so lets create some objects.
For example we use objects like this in our program:

peter := AMMHuman new.
john := AMMHuman new.
greta := AMMHuman new.
peter father: john.
peter mother: greta.

app addRoot: peter.

Please execute the code.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:38.945'!
sequence04RemoveOneObjects
	
	self doOnce: [ self disableNextButton ].

	self showMessage: 'In the meantime, Peter and John had a big fight and do not speak with each other anymore.
	
Therefore we want to remove the reference from Peter to John. Execute:

peter endsFriendshipWith: john

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:46.328'!
sequence05ExplainUnneededMemory
	
	self showMessage: 'Hence, John is the only object which is reachable globally, Peter is not accessable anymore and could be removed from the memory.
	

'.
! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:01:50.945'!
sequence06CreateMoreObjects 

	self doOnce: [ self disableNextButton ].
	
	self showMessage: 'Ok, now we have a couple of objects in our memory.

And we want to create further objects.

Therefore, please create a new object with executing the following line (just select it and hit cmd-d):

new MyObject
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/29/2013 10:03:51.692'!
sequence07OutOfMemory 
	
"	self doOnce: [ self disableNextButton. self enablePlayControls ].
"	
	self showMessage: 'Ups, we are out of memory now.
Almost at least. Our memory is filled with objects, but not all of them are needed anymore.

Here the automatical garbage collection helps out.

As you have learned before, mark and sweep is an start-stop algorithm, which interrupts the user program completely.
This happens now.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:26:52.958'!
sequence08KindOfReachableObjects
	
	self showMessage: 'The first phase of mark and sweep is about finding referenced objects.
There are 2 different types of reachable objects.

1st: root objects (which are highlighted with a red border in the object graph).
These objects are accessable globally.

2nd: referenced objects
To find out, which objects are reachable, we have to traverse all references of reachable objects.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/27/2013 17:33:45.094'!
sequence09FirstPhase
	
	self doOnce: [ self disableNextButton ].

	self showMessage: 'The garbage collector has to mark objects in the memory and needs a storage for that.
Therefore before the first phase can start, the garbage collector has to reset the storage. 

You can think about it, as the 0th phase.
	
We iterate over all objects in our memory (heap) and reset the storage.
	
objects do: 
	[ :object | object setState: clear ]	

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 21:43:23.495'!
sequence10ExplainRecursiveMark
	
	self showMessage: 'Well, now we have a consistent state.
	
We can search for all reachable objects!! This is done recursively.

During the marking phase, when an object has not been marked before it is marked. Afterwards all referenced objects are visited and marked.

Object >> mark
	(self markingState !!= #set)
		ifTrue: [
			self markingState: #set.
			self references do: [ :object | 
				object mark.
				].
		]

Your are just one "next"-click away from seeing your first garbage collection!!
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 21:45:07.093'!
sequence11ExecuteMark
	
	self doOnce: [ self disableNextButton ].
	
	self showMessage: 'This mark is executed for every root-object - so for every object which is reachable globally.
	
Therefore, please go ahead and execute the following lines of code!!
	
rootObjects do: [:object |
	object mark.
	]

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 22:46:46.298'!
sequence12ExplainResultOfMark
	
	self showMessage: 'Do you see the big gap between the first object (Peter) and the third (Greta). This space is used to store data for the second obejct(John) we created. Hence this data is not accessible anymore, it is completely useless and can be freed.
	
Click next to learn about the 2nd phase of Mark and Sweep.
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 22:59:45.712'!
sequence13IntroduceSweep
	
	self showMessage: 'At this point of time, we have analysed our memory and found all objects which are still in use.

Now, we have to iterate over all cells of our memory to check, if there are some unused objects in there.

Just to clarify things, a quick reminder.
In the 0th phase, we reset the state of all objects in memory.
In the 1st phase, we mark all reachable objects, which is usually only a subset of all objects.
In the 2nd phase (now), we iterate over all objects in our memory again, to remove all unreachable ones. 

Go ahead and click "Next"!!!!
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 23:04:26.882'!
sequence14ExecuteSweep
	
	self doOnce: [ self disableNextButton ].

	self showMessage: 'Now, we have to iterate over all objects in our memory (heap) and delete them from the storage if they were not accessed in the 2nd phase.

Execute it!!!!

objects do: 
	[ :object | 
		(object markingState !!= #set) 
			ifTrue: [ object delete ] ]	
	
'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 23:17:05.354'!
sequence15ResultOfSweep

	nextFreeObjectAddresses := 13.
	self doOnce: [ self disableNextButton ].
	self showMessage: 'Awesome, you just finished your first (automatic) garbage collection!! Congratulation, user program has enough space available and can store new objects again!!
	
Now, the interruption of the program ends.
Create further objects again!!

new MyObject

'! !

!AMMUnit1 methodsFor: 'unit-sequences' stamp: 'sw 5/28/2013 23:18:30.834'!
sequence16AgainOutOfSpace
	
	self showMessage: 'This can go on, until you are out of space again.
	
At this stage, we would execute the garbage collection again. 
But, unfortunately we would not free any space - hence all objects are reachable and necessary.

'! !

AMMUnit subclass: #AMMUnitExplorative
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Units'!

!AMMUnitExplorative class methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 10:07:49.311'!
nameOfUnit 
	
	^ 'Explorative mode'! !

!AMMUnitExplorative methodsFor: 'as yet unclassified' stamp: 'sw 6/7/2013 08:56:39.785'!
sequence01Start 

	self showMessage:
'Play around!!!!

ball := AMMSimpleBall new.
coloredball := AMMColoredBall new.

app addObject: ball.
app addObject: coloredball.

paul := AMMHuman new.
paul name:''Paul''.

peter := AMMHuman new.
peter name: ''Peter''.

paul father: peter.
app addObject: paul.
'.
! !

!Object methodsFor: '*AMMStudio' stamp: 'sw 6/3/2013 13:45:38.652'!
isAMMAlgorithm

	^ false! !

Error subclass: #AMMMemoryError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMMemoryError subclass: #AMMHeapOutOfSpaceError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

AMMMemoryError subclass: #AMMObjectIsNotExtended
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

UserInterface subclass: #AMMStudioUi
	instanceVariableNames: 'comboUnits buttonPause buttonPlay buttonStep sourceCodeEdit buttonPrevious buttonNext devButton containerHeapGC containerHeap containerGC containerGraph scrollAreaGraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.658'!
buttonNext
	"No description given."
	
	^ buttonNext! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.646'!
buttonPause
	"No description given."
	
	^ buttonPause! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.649'!
buttonPlay
	"Play Scenario"
	
	^ buttonPlay! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.656'!
buttonPrevious
	"No description given."
	
	^ buttonPrevious! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.652'!
buttonStep
	"GC Stepping"
	
	^ buttonStep! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.643'!
comboUnits
	"No description given."
	
	^ comboUnits! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.665'!
containerGC	
	"container for gc"
	
	^ containerGC	! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.667'!
containerGraph
	"No description given."
	
	^ containerGraph! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.663'!
containerHeap
	"container for heap representation"
	
	^ containerHeap! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.662'!
containerHeapGC
	"Container for the heap presentation and gc"
	
	^ containerHeapGC! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.66'!
devButton
	"No description given."
	
	^ devButton! !

!AMMStudioUi methodsFor: 'ui - private' stamp: 'sw 6/3/2013 12:28:30.713'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (532@466).
	panel position: (0@0).
	panel hResizing: (#shrinkWrap).
	panel vResizing: (#shrinkWrap).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#topLeft).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (352@458).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (300).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (344@30).
	unnamedMorph2 position: (8@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#shrinkWrap).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#topLeft).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#leftToRight).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 setProperty: #objectDescription toValue: 'Container for the heap presentation'.
	comboUnits := UiComboBox new.
	comboUnits extent: (110@21).
	comboUnits position: (12@12).
	comboUnits hResizing: (#rigid).
	comboUnits vResizing: (#rigid).
	comboUnits minWidth: (2).
	comboUnits minHeight: (2).
	comboUnits cellInset: (0).
	comboUnits cellPositioning: (#center).
	comboUnits cellSpacing: (#none).
	comboUnits layoutInset: (0).
	comboUnits listCentering: (#topLeft).
	comboUnits listDirection: (#topToBottom).
	comboUnits listSpacing: (#none).
	comboUnits maxCellSize: (1073741823).
	comboUnits minCellSize: (0).
	comboUnits wrapCentering: (#topLeft).
	comboUnits wrapDirection: (#none).
	comboUnits frameFractions: (0@0 corner: 1@1).
	comboUnits frameOffsets: (0@0 corner: 0@0).
	comboUnits balloonText: (nil).
	comboUnits balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	comboUnits readOnly: (true).
	comboUnits setProperty: #objectName toValue: 'comboUnits'.
	unnamedMorph2 addChild: comboUnits.
	buttonPause := UiPushButton new.
	buttonPause changeTableLayout.
	buttonPause extent: (60@21).
	buttonPause position: (128@12).
	buttonPause hResizing: (#shrinkWrap).
	buttonPause vResizing: (#shrinkWrap).
	buttonPause minWidth: (2).
	buttonPause minHeight: (2).
	buttonPause cellInset: (4).
	buttonPause cellPositioning: (#center).
	buttonPause cellSpacing: (#none).
	buttonPause layoutInset: (2@0 corner: 2@0).
	buttonPause listCentering: (#topLeft).
	buttonPause listDirection: (#leftToRight).
	buttonPause listSpacing: (#none).
	buttonPause maxCellSize: (1073741823).
	buttonPause minCellSize: (0).
	buttonPause wrapCentering: (#topLeft).
	buttonPause wrapDirection: (#none).
	buttonPause frameFractions: (0@0 corner: 1@1).
	buttonPause frameOffsets: (0@0 corner: 0@0).
	buttonPause balloonText: (nil).
	buttonPause balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonPause enabled: (true).
	buttonPause setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0341Normal'.
	buttonPause icon: (UiDiagonaIcons icon0341Normal).
	buttonPause text: ('Pause').
	buttonPause color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPause checkable: (false).
	buttonPause checked: (false).
	buttonPause autoExclusive: (false).
	buttonPause setProperty: #objectName toValue: 'buttonPause'.
	unnamedMorph2 addChild: buttonPause.
	buttonPlay := UiPushButton new.
	buttonPlay changeTableLayout.
	buttonPlay extent: (49@21).
	buttonPlay position: (194@12).
	buttonPlay hResizing: (#shrinkWrap).
	buttonPlay vResizing: (#shrinkWrap).
	buttonPlay minWidth: (2).
	buttonPlay minHeight: (2).
	buttonPlay cellInset: (4).
	buttonPlay cellPositioning: (#center).
	buttonPlay cellSpacing: (#none).
	buttonPlay layoutInset: (2@0 corner: 2@0).
	buttonPlay listCentering: (#topLeft).
	buttonPlay listDirection: (#leftToRight).
	buttonPlay listSpacing: (#none).
	buttonPlay maxCellSize: (1073741823).
	buttonPlay minCellSize: (0).
	buttonPlay wrapCentering: (#topLeft).
	buttonPlay wrapDirection: (#none).
	buttonPlay frameFractions: (0@0 corner: 1@1).
	buttonPlay frameOffsets: (0@0 corner: 0@0).
	buttonPlay balloonText: (nil).
	buttonPlay balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonPlay enabled: (true).
	buttonPlay setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	buttonPlay icon: (UiDiagonaIcons icon0331Normal).
	buttonPlay text: ('Play').
	buttonPlay color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPlay checkable: (false).
	buttonPlay checked: (false).
	buttonPlay autoExclusive: (false).
	buttonPlay setProperty: #objectName toValue: 'buttonPlay'.
	buttonPlay setProperty: #objectDescription toValue: 'Play Scenario'.
	unnamedMorph2 addChild: buttonPlay.
	buttonStep := UiPushButton new.
	buttonStep changeTableLayout.
	buttonStep extent: (52@21).
	buttonStep position: (249@12).
	buttonStep hResizing: (#shrinkWrap).
	buttonStep vResizing: (#shrinkWrap).
	buttonStep minWidth: (2).
	buttonStep minHeight: (2).
	buttonStep cellInset: (4).
	buttonStep cellPositioning: (#center).
	buttonStep cellSpacing: (#none).
	buttonStep layoutInset: (2@0 corner: 2@0).
	buttonStep listCentering: (#topLeft).
	buttonStep listDirection: (#leftToRight).
	buttonStep listSpacing: (#none).
	buttonStep maxCellSize: (1073741823).
	buttonStep minCellSize: (0).
	buttonStep wrapCentering: (#topLeft).
	buttonStep wrapDirection: (#none).
	buttonStep frameFractions: (0@0 corner: 1@1).
	buttonStep frameOffsets: (0@0 corner: 0@0).
	buttonStep balloonText: (nil).
	buttonStep balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonStep enabled: (true).
	buttonStep setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0343Normal'.
	buttonStep icon: (UiDiagonaIcons icon0343Normal).
	buttonStep text: ('Step').
	buttonStep color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonStep checkable: (false).
	buttonStep checked: (false).
	buttonStep autoExclusive: (false).
	buttonStep setProperty: #objectName toValue: 'buttonStep'.
	buttonStep setProperty: #objectDescription toValue: 'GC Stepping'.
	unnamedMorph2 addChild: buttonStep.
	unnamedMorph1 addChild: unnamedMorph2.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (344@415).
	unnamedMorph3 position: (8@43).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#spaceFill).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	sourceCodeEdit := AMMSourceCodeEdit new.
	sourceCodeEdit extent: (336@373).
	sourceCodeEdit position: (12@47).
	sourceCodeEdit hResizing: (#spaceFill).
	sourceCodeEdit vResizing: (#spaceFill).
	sourceCodeEdit minWidth: (2).
	sourceCodeEdit minHeight: (2).
	sourceCodeEdit cellInset: (0).
	sourceCodeEdit cellPositioning: (#center).
	sourceCodeEdit cellSpacing: (#none).
	sourceCodeEdit layoutInset: (0).
	sourceCodeEdit listCentering: (#topLeft).
	sourceCodeEdit listDirection: (#topToBottom).
	sourceCodeEdit listSpacing: (#none).
	sourceCodeEdit maxCellSize: (1073741823).
	sourceCodeEdit minCellSize: (0).
	sourceCodeEdit wrapCentering: (#topLeft).
	sourceCodeEdit wrapDirection: (#none).
	sourceCodeEdit frameFractions: (0@0 corner: 1@1).
	sourceCodeEdit frameOffsets: (0@0 corner: 0@0).
	sourceCodeEdit balloonText: (nil).
	sourceCodeEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	sourceCodeEdit widgetResizable: (true).
	sourceCodeEdit horizontalScrollBarPolicy: (#alwaysOff).
	sourceCodeEdit verticalScrollBarPolicy: (#alwaysOn).
	sourceCodeEdit outerBorderWidth: (1).
	sourceCodeEdit scrollBarThickness: (9).
	sourceCodeEdit theText: ('').
	sourceCodeEdit readOnly: (false).
	sourceCodeEdit autoConvert: (false).
	sourceCodeEdit autoAccept: (false).
	sourceCodeEdit acceptOnFocusLost: (false).
	sourceCodeEdit scrollingMode: (#none).
	sourceCodeEdit scrollingLimit: (10).
	sourceCodeEdit setProperty: #objectName toValue: 'sourceCodeEdit'.
	unnamedMorph3 addChild: sourceCodeEdit.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (336@30).
	unnamedMorph4 position: (12@424).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	buttonPrevious := UiPushButton new.
	buttonPrevious changeTableLayout.
	buttonPrevious extent: (75@21).
	buttonPrevious position: (16@428).
	buttonPrevious hResizing: (#shrinkWrap).
	buttonPrevious vResizing: (#shrinkWrap).
	buttonPrevious minWidth: (2).
	buttonPrevious minHeight: (2).
	buttonPrevious cellInset: (4).
	buttonPrevious cellPositioning: (#center).
	buttonPrevious cellSpacing: (#none).
	buttonPrevious layoutInset: (2@0 corner: 2@0).
	buttonPrevious listCentering: (#topLeft).
	buttonPrevious listDirection: (#leftToRight).
	buttonPrevious listSpacing: (#none).
	buttonPrevious maxCellSize: (1073741823).
	buttonPrevious minCellSize: (0).
	buttonPrevious wrapCentering: (#topLeft).
	buttonPrevious wrapDirection: (#none).
	buttonPrevious frameFractions: (0@0 corner: 1@1).
	buttonPrevious frameOffsets: (0@0 corner: 0@0).
	buttonPrevious balloonText: (nil).
	buttonPrevious balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	buttonPrevious enabled: (true).
	buttonPrevious setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0332Normal'.
	buttonPrevious icon: (UiDiagonaIcons icon0332Normal).
	buttonPrevious text: ('Previous').
	buttonPrevious color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonPrevious checkable: (false).
	buttonPrevious checked: (false).
	buttonPrevious autoExclusive: (false).
	buttonPrevious setProperty: #objectName toValue: 'buttonPrevious'.
	unnamedMorph4 addChild: buttonPrevious.
	buttonNext := UiPushButton new.
	buttonNext changeTableLayout.
	buttonNext extent: (53@21).
	buttonNext position: (97@428).
	buttonNext hResizing: (#shrinkWrap).
	buttonNext vResizing: (#shrinkWrap).
	buttonNext minWidth: (2).
	buttonNext minHeight: (2).
	buttonNext cellInset: (4).
	buttonNext cellPositioning: (#center).
	buttonNext cellSpacing: (#none).
	buttonNext layoutInset: (2@0 corner: 2@0).
	buttonNext listCentering: (#topLeft).
	buttonNext listDirection: (#leftToRight).
	buttonNext listSpacing: (#none).
	buttonNext maxCellSize: (1073741823).
	buttonNext minCellSize: (0).
	buttonNext wrapCentering: (#topLeft).
	buttonNext wrapDirection: (#none).
	buttonNext frameFractions: (0@0 corner: 1@1).
	buttonNext frameOffsets: (0@0 corner: 0@0).
	buttonNext balloonText: (nil).
	buttonNext balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	buttonNext enabled: (true).
	buttonNext setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	buttonNext icon: (UiDiagonaIcons icon0331Normal).
	buttonNext text: ('Next').
	buttonNext color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	buttonNext checkable: (false).
	buttonNext checked: (false).
	buttonNext autoExclusive: (false).
	buttonNext setProperty: #objectName toValue: 'buttonNext'.
	unnamedMorph4 addChild: buttonNext.
	devButton := UiPushButton new.
	devButton changeTableLayout.
	devButton extent: (117@21).
	devButton position: (156@428).
	devButton hResizing: (#shrinkWrap).
	devButton vResizing: (#shrinkWrap).
	devButton minWidth: (2).
	devButton minHeight: (2).
	devButton cellInset: (4).
	devButton cellPositioning: (#center).
	devButton cellSpacing: (#none).
	devButton layoutInset: (2@0 corner: 2@0).
	devButton listCentering: (#topLeft).
	devButton listDirection: (#leftToRight).
	devButton listSpacing: (#none).
	devButton maxCellSize: (1073741823).
	devButton minCellSize: (0).
	devButton wrapCentering: (#topLeft).
	devButton wrapDirection: (#none).
	devButton frameFractions: (0@0 corner: 1@1).
	devButton frameOffsets: (0@0 corner: 0@0).
	devButton balloonText: (nil).
	devButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	devButton enabled: (true).
	devButton setProperty: #iconByDesigner toValue: 'nil'.
	devButton icon: (nil).
	devButton text: ('developmentMode').
	devButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	devButton checkable: (false).
	devButton checked: (false).
	devButton autoExclusive: (false).
	devButton setProperty: #objectName toValue: 'devButton'.
	unnamedMorph4 addChild: devButton.
	unnamedMorph3 addChild: unnamedMorph4.
	unnamedMorph1 addChild: unnamedMorph3.
	panel addChild: unnamedMorph1.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (168@458).
	unnamedMorph5 position: (360@4).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#spaceFill).
	unnamedMorph5 minWidth: (120).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	containerHeapGC := UiContainer new.
	containerHeapGC changeTableLayout.
	containerHeapGC extent: (160@108).
	containerHeapGC position: (364@8).
	containerHeapGC hResizing: (#spaceFill).
	containerHeapGC vResizing: (#shrinkWrap).
	containerHeapGC minWidth: (2).
	containerHeapGC minHeight: (2).
	containerHeapGC cellInset: (4).
	containerHeapGC cellPositioning: (#center).
	containerHeapGC cellSpacing: (#none).
	containerHeapGC layoutInset: (4).
	containerHeapGC listCentering: (#topLeft).
	containerHeapGC listDirection: (#leftToRight).
	containerHeapGC listSpacing: (#none).
	containerHeapGC maxCellSize: (1073741823).
	containerHeapGC minCellSize: (0).
	containerHeapGC wrapCentering: (#topLeft).
	containerHeapGC wrapDirection: (#none).
	containerHeapGC frameFractions: (0@0 corner: 1@1).
	containerHeapGC frameOffsets: (0@0 corner: 0@0).
	containerHeapGC balloonText: (nil).
	containerHeapGC balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerHeapGC color: (Color lightGray).
	containerHeapGC borderWidth: (0).
	containerHeapGC borderStyle2: (#simple).
	containerHeapGC borderColor: (Color black).
	containerHeapGC setProperty: #objectName toValue: 'containerHeapGC'.
	containerHeapGC setProperty: #objectDescription toValue: 'Container for the heap presentation and gc'.
	containerHeap := UiContainer new.
	containerHeap changeTableLayout.
	containerHeap extent: (48@100).
	containerHeap position: (368@12).
	containerHeap hResizing: (#spaceFill).
	containerHeap vResizing: (#rigid).
	containerHeap minWidth: (2).
	containerHeap minHeight: (2).
	containerHeap cellInset: (4).
	containerHeap cellPositioning: (#center).
	containerHeap cellSpacing: (#none).
	containerHeap layoutInset: (0).
	containerHeap listCentering: (#topLeft).
	containerHeap listDirection: (#leftToRight).
	containerHeap listSpacing: (#none).
	containerHeap maxCellSize: (1073741823).
	containerHeap minCellSize: (0).
	containerHeap wrapCentering: (#topLeft).
	containerHeap wrapDirection: (#none).
	containerHeap frameFractions: (0@0 corner: 1@1).
	containerHeap frameOffsets: (0@0 corner: 0@0).
	containerHeap balloonText: (nil).
	containerHeap balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.945)).
	containerHeap color: (Color transparent).
	containerHeap borderWidth: (0).
	containerHeap borderStyle2: (#simple).
	containerHeap borderColor: (Color black).
	containerHeap setProperty: #objectName toValue: 'containerHeap'.
	containerHeap setProperty: #objectDescription toValue: 'container for heap representation'.
	containerHeapGC addChild: containerHeap.
	containerGC	 := UiContainer new.
	containerGC	 changeTableLayout.
	containerGC	 extent: (100@100).
	containerGC	 position: (420@12).
	containerGC	 hResizing: (#rigid).
	containerGC	 vResizing: (#rigid).
	containerGC	 minWidth: (2).
	containerGC	 minHeight: (2).
	containerGC	 cellInset: (0).
	containerGC	 cellPositioning: (#center).
	containerGC	 cellSpacing: (#none).
	containerGC	 layoutInset: (0).
	containerGC	 listCentering: (#topLeft).
	containerGC	 listDirection: (#leftToRight).
	containerGC	 listSpacing: (#none).
	containerGC	 maxCellSize: (1073741823).
	containerGC	 minCellSize: (0).
	containerGC	 wrapCentering: (#topLeft).
	containerGC	 wrapDirection: (#none).
	containerGC	 frameFractions: (0@0 corner: 1@1).
	containerGC	 frameOffsets: (0@0 corner: 0@0).
	containerGC	 balloonText: (nil).
	containerGC	 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerGC	 color: (Color transparent).
	containerGC	 borderWidth: (0).
	containerGC	 borderStyle2: (#simple).
	containerGC	 borderColor: (Color black).
	containerGC	 setProperty: #objectName toValue: 'containerGC	'.
	containerGC	 setProperty: #objectDescription toValue: 'container for gc'.
	containerHeapGC addChild: containerGC	.
	unnamedMorph5 addChild: containerHeapGC.
	containerGraph := UiContainer new.
	containerGraph changeTableLayout.
	containerGraph extent: (160@338).
	containerGraph position: (364@120).
	containerGraph hResizing: (#spaceFill).
	containerGraph vResizing: (#spaceFill).
	containerGraph minWidth: (2).
	containerGraph minHeight: (2).
	containerGraph cellInset: (4).
	containerGraph cellPositioning: (#center).
	containerGraph cellSpacing: (#none).
	containerGraph layoutInset: (4).
	containerGraph listCentering: (#topLeft).
	containerGraph listDirection: (#topToBottom).
	containerGraph listSpacing: (#none).
	containerGraph maxCellSize: (1073741823).
	containerGraph minCellSize: (0).
	containerGraph wrapCentering: (#topLeft).
	containerGraph wrapDirection: (#none).
	containerGraph frameFractions: (0@0 corner: 1@1).
	containerGraph frameOffsets: (0@0 corner: 0@0).
	containerGraph balloonText: (nil).
	containerGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	containerGraph color: (Color lightGray).
	containerGraph borderWidth: (0).
	containerGraph borderStyle2: (#simple).
	containerGraph borderColor: (Color black).
	containerGraph setProperty: #objectName toValue: 'containerGraph'.
	scrollAreaGraph := ViScrollArea new.
	scrollAreaGraph extent: (152@330).
	scrollAreaGraph position: (368@124).
	scrollAreaGraph hResizing: (#spaceFill).
	scrollAreaGraph vResizing: (#spaceFill).
	scrollAreaGraph minWidth: (2).
	scrollAreaGraph minHeight: (2).
	scrollAreaGraph cellInset: (0).
	scrollAreaGraph cellPositioning: (#center).
	scrollAreaGraph cellSpacing: (#none).
	scrollAreaGraph layoutInset: (0).
	scrollAreaGraph listCentering: (#topLeft).
	scrollAreaGraph listDirection: (#topToBottom).
	scrollAreaGraph listSpacing: (#none).
	scrollAreaGraph maxCellSize: (1073741823).
	scrollAreaGraph minCellSize: (0).
	scrollAreaGraph wrapCentering: (#topLeft).
	scrollAreaGraph wrapDirection: (#none).
	scrollAreaGraph frameFractions: (0@0 corner: 1@1).
	scrollAreaGraph frameOffsets: (0@0 corner: 0@0).
	scrollAreaGraph balloonText: (nil).
	scrollAreaGraph balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	scrollAreaGraph widgetResizable: (false).
	scrollAreaGraph horizontalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph verticalScrollBarPolicy: (#alwaysOn).
	scrollAreaGraph outerBorderWidth: (0).
	scrollAreaGraph scrollBarThickness: (9).
	scrollAreaGraph setProperty: #objectName toValue: 'scrollAreaGraph'.
	containerGraph addChild: scrollAreaGraph.
	unnamedMorph5 addChild: containerGraph.
	panel addChild: unnamedMorph5.
	panel setProperty: #uiClassName toValue: 'AMMStudio'.! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.669'!
scrollAreaGraph
	"No description given."
	
	^ scrollAreaGraph! !

!AMMStudioUi methodsFor: 'accessing' stamp: 'sw 6/3/2013 12:28:30.654'!
sourceCodeEdit
	"No description given."
	
	^ sourceCodeEdit! !

Morph subclass: #AMMStudio
	instanceVariableNames: 'ui heap objectgraph gc currentUnit currentApplication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMStudio class methodsFor: 'as yet unclassified' stamp: 'sw 5/26/2013 16:01:38.96'!
open

	^ self new openInWindowLabeled: 'AMM Studio'.! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/4/2013 09:41:26.994'!
bindingFor: anObject

	self bindings keysAndValuesDo: [:key :value | 
		(value = anObject ) ifTrue: [ ^ key ]
		].
	^ nil! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/4/2013 09:37:29.519'!
bindings 

	^ self ui sourceCodeEdit model bindings ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/3/2013 14:48:07.314'!
currentApplication

	^ currentApplication! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 6/3/2013 14:48:07.317'!
currentApplication: anObject

	currentApplication := anObject! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:48:54.013'!
currentUnit

	^ currentUnit! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 11:49:15.468'!
currentUnit: anAMMUnit

	currentUnit := anAMMUnit! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/3/2013 12:29:58.345'!
disablePlayControls

	World stopStepping: self.
	self ui buttonPause enabled: false.	
	self ui buttonStep enabled: false.		
	self ui buttonPlay enabled: false.		! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/3/2013 12:29:53.495'!
enablePlayControls

	self ui buttonPause enabled: false.	
	self ui buttonStep enabled: true.		
	self ui buttonPlay enabled: true.		! !

!AMMStudio methodsFor: 'accessing' stamp: 'rm 6/2/2013 16:57:34.648'!
gc

	^ gc! !

!AMMStudio methodsFor: 'accessing' stamp: 'rm 6/2/2013 16:57:31.198'!
gc: aGarbageCollector

	gc := aGarbageCollector! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/3/2013 14:21:12.823'!
gcStep

	self gc step.
	self refreshObjectRepresentations.
	Transcript show: 'step '.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 14:11:28.308'!
handleEventDevelopmentMode
! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:43:28.137'!
handleEventDisableNextButton

	self ui buttonNext enabled: false.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 11:10:29.183'!
handleEventEnableNextButton

	self ui buttonNext enabled: true.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 09:55:55.416'!
handleEventErrorOccured: anErrorMessage
	
	self ui sourceCodeEdit textMorph editor afterSelectionInsertAndSelect: anErrorMessage.! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 11:09:37.19'!
handleEventMakeObjectReachable: anObject withLabel: aLabel
	"Put the object into the binding dictionary of the workspace model - if it isn't there already. "

	(self bindingFor: anObject = aLabel) 
		ifTrue: [ ^ self ].
	self bindings at: aLabel put: anObject.
! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 10:05:19.913'!
handleEventObjectsChanged

	self refreshObjectRepresentations 
! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 11:08:12.082'!
handleEventSetGCAlgorithm: anAlgorithm

	self gc algorithm: anAlgorithm! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:47:50.59'!
handleEventShowMessage: aMessage

	self ui sourceCodeEdit theText: aMessage ! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:47:31.144'!
handleEventSourceCodeExecuted: aResult
	| selectedCode |
	
	selectedCode := self ui sourceCodeEdit textMorph selection.
	
	self currentApplication setReachableObjectsAsRoot: self bindings values.
	 
	self currentUnit sourceCodeExecuted: selectedCode withBindings: self bindings withResult: aResult.
	
	self refreshObjectRepresentations.
	! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:50:56.739'!
handleEventStoreObjectInMemory: anObject 

	self currentApplication addObject: anObject! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/4/2013 13:49:24.511'!
handleEventUnitFinished

	self startNextUnit.
	! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:53:16.717'!
heap

	^ heap! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 13:54:09.601'!
heap: aHeap

	heap := aHeap! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 6/4/2013 10:07:18.307'!
initialize 

	super initialize.
	self ui setupUi: self.

	self extent:800@500.
	
	self initializeUnits.
	self initializeGraphicalRepresentations.	

	self startUnit: AMMUnitExplorative new.
	
	self disablePlayControls.


	self registerSignalsForGeneralControls.
	
! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 6/3/2013 14:44:30.079'!
initializeGraphicalRepresentations

	self heap: (AMMHeap new).
	self ui containerHeap addMorph: self heap.
	
	self gc: (AMMGarbageCollector new).
	self ui containerGC addMorph: self gc.
	
	self objectgraph: (AMMObjectGraph new).
	self ui scrollAreaGraph widget: self objectgraph.
! !

!AMMStudio methodsFor: 'initialization' stamp: 'sw 5/16/2013 11:13:11.437'!
initializeUnits
	
	|subclasses|
	
	subclasses := AMMUnit allSubclasses.
	subclasses sort: [ :classA :classB | classA name asString < classB name asString ].
	self ui comboUnits 
		addItemListFrom: subclasses
		using: [:unit :listItem | 
			listItem text: unit nameOfUnit. 
			listItem data: unit. ].
		
! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/16/2013 10:48:04.084'!
next

	(self currentUnit isNil) 
		ifFalse: [ self currentUnit next ]! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/27/2013 16:46:08.043'!
nextSequence

	self currentUnit next! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:00:51.495'!
objectgraph

	^ objectgraph ! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 5/13/2013 14:01:26.257'!
objectgraph: anObjectgraph

	objectgraph := anObjectgraph! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/27/2013 16:46:17.193'!
previousSequence

	self currentUnit previous! !

!AMMStudio methodsFor: 'events-processing' stamp: 'sw 6/3/2013 23:24:36.63'!
refreshObjectRepresentations

	Transcript show: 'refresh view'; cr.
	self objectgraph render.
	self heap render.
	self gc render.
! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/4/2013 11:08:30.792'!
registerSignalsForCurrentApplication

	self connect: self currentApplication signal: #setGCAlgorithm: toSelector: #handleEventSetGCAlgorithm: pattern: #(1).
	
	self connect: self currentApplication signal: #errorOccured: toSelector: #handleEventErrorOccured: pattern: #(1).
	
	self connect: self currentApplication signal: #objectsChanged toSelector: #handleEventObjectsChanged.
! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/4/2013 13:50:01.279'!
registerSignalsForCurrentUnit

	self connect: self currentUnit signal: #showMessage: toSelector: #handleEventShowMessage: pattern: #(1).
	
	self connect: self currentUnit signal: #stopAutoplay toSelector: #stopAutoplay.
	self connect: self currentUnit signal: #startAutoplay toSelector: #startAutoplay.
	
	
	self connect: self currentUnit signal: #finished toSelector: #handleEventUnitFinished.

	self connect: self currentUnit signal: #enableNextButton toSelector: #handleEventEnableNextButton.
	self connect: self currentUnit signal: #disableNextButton toSelector: #handleEventDisableNextButton.

	self connect: self currentUnit signal: #enablePlayControls toSelector: #enablePlayControls.
	self connect: self currentUnit signal: #disablePlayControls toSelector: #disablePlayControls.
	
	self connect: self currentUnit signal: #setGCAlgorithm: toSelector: #handleEventSetGCAlgorithm: pattern: #(1).
	
	self connect: self currentUnit signal: #storeObjectInMemory: toSelector: #handleEventStoreObjectInMemory: pattern:#(1).
	self connect: self currentUnit signal: #makeObjectReachable:withLabel: toSelector: #handleEventMakeObjectReachable:withLabel:  pattern:#(1 2).
! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/4/2013 14:11:23.933'!
registerSignalsForGeneralControls

	self connect: self ui buttonStep signal:#clicked: toSelector: #gcStep.
	self connect: self ui buttonPlay signal:#clicked: toSelector: #startAutoplay.	
	self connect: self ui buttonNext signal:#clicked: toSelector: #nextSequence.
	
	self connect: self ui buttonPause signal:#clicked: toSelector: #stopAutoplay.

	self connect: self ui buttonPrevious signal:#clicked: toSelector: #previousSequence.
	self connect: self ui devButton signal:#clicked: toSelector: #handleEventDevelopmentMode.
		
	self connect: self ui comboUnits signal: #currentTextChanged: toSelector: #selectUnit.
	
	
	" submorph (AMMSourceCodeTextMorph) emits signal and forwards it via all owner morphs - use of vivide-signals ;-("	
	self sgConnectSignal: #expressionEvaluated: toSelector:  #handleEventSourceCodeExecuted: pattern: #(1).
	! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/16/2013 11:31:34.541'!
selectUnit

	self startUnit: (self ui comboUnits currentItem data new).! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/3/2013 12:29:47.298'!
startAutoplay
	
	" trigger frequently step method "

	World
		startStepping: self
		at: Time millisecondClockValue
		selector: #gcStep
		arguments: { }
		stepTime: 1000.

	self ui buttonPause enabled: true.	
	self ui buttonStep enabled: false.		
	self ui buttonPlay enabled: false.		! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 5/26/2013 15:58:41.272'!
startNextUnit

	self ui comboUnits currentIndex: (self ui comboUnits currentIndex +1).
	! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/6/2013 13:46:52.993'!
startUnit: anUnit

	| metaObjects |
	
	self unregisterSignalsForCurrentApplication.	
	self currentApplication: AMMApplication new.
	self currentApplication heap: self heap.
	self ui sourceCodeEdit model bindings at: 'app' put: self currentApplication.
	metaObjects := self currentApplication metaObjects.
	self gc objects: metaObjects.
	self objectgraph objects: metaObjects.
	self heap objects: metaObjects.	
	self registerSignalsForCurrentApplication.
	
	self unregisterSignalsForCurrentUnit.	
	self currentUnit: anUnit.
	


	self registerSignalsForCurrentUnit.
	
	self currentUnit next.! !

!AMMStudio methodsFor: 'processing-units' stamp: 'sw 6/3/2013 12:29:40.745'!
stopAutoplay

	World stopStepping: self.
	self ui buttonPause enabled: false.	
	self ui buttonStep enabled: true.		
	self ui buttonPlay enabled: true.		! !

!AMMStudio methodsFor: 'accessing' stamp: 'sw 4/29/2013 12:05:54.615'!
ui
	
	^ ui ifNil: [ ui:= AMMStudioUi new ]! !

!AMMStudio methodsFor: 'accessing' stamp: 'ci 5/10/2013 17:44:40.556'!
ui: anObject

	ui := anObject! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/4/2013 09:55:34.336'!
unregisterSignalsForCurrentApplication

	(self currentApplication isNil) 
		ifFalse: [
			self disconnectSignal: #setGCAlgorithm: from: self currentApplication.
			self disconnectSignal: #objectsChanged from: self currentApplication.
			self disconnectSignal: #errorOccured: from: self currentApplication.
		]
	! !

!AMMStudio methodsFor: 'events-listening' stamp: 'sw 6/4/2013 09:46:13.748'!
unregisterSignalsForCurrentUnit

	(self currentUnit isNil) 
		ifFalse: [ 
			self currentUnit objects 
				do:[ :obj | 
					self disconnectSignal: #changed from: obj.
				].
			self disconnectSignal: #showMessage: from: self currentUnit.
			self disconnectSignal: #finished  from: self currentUnit.
			self disconnectSignal: #stopAutoplay from: self currentUnit.
			self disconnectSignal: #startAutoplay from: self currentUnit.

			self disconnectSignal: #enableNextButton from: self currentUnit.
			self disconnectSignal: #disableNextButton from: self currentUnit.

			self disconnectSignal: #objectsChanged from: self currentUnit.

		].


! !

SHTextStylerST80 subclass: #AMMTextStyler
	instanceVariableNames: 'customTextAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMTextStyler commentStamp: '<historical>' prior: 0!
Regular Shout text styler with the ability to override some attributes dynamically.!

!AMMTextStyler class methodsFor: 'style table' stamp: 'sw 6/1/2013 10:49:11.113'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
						
	(default 								( black )	)
	(invalid 								( red ) 	)
	(excessCode 							( red )	)
	(comment 								( green	muchDarker ) nil	#'Bitmap Segoe UI' 15)
	(unfinishedComment 					( green	muchDarker )	)
	(#'$'									( magenta muchDarker) 	)
	(character							( magenta muchDarker) 	)
	(integer								( magenta muchDarker) 	)
	(number								( magenta muchDarker) 	)
	(#-										( magenta muchDarker) 	)
	(symbol									( magenta muchDarker) 	)	
	(stringSymbol							( magenta muchDarker) 	)	
	(literalArray							( magenta muchDarker) 	)
	(string									( magenta ) 	)
	(unfinishedString						( magenta ) 	)
	(assignment								( black )					)
	(ansiAssignment 						( black )					)
	(literal									( black )					)
	(keyword								( black )					)
	(binary 								( black )					)
	(unary									( black )					)
	(incompleteKeyword						( black )					)
	(incompleteBinary 						( black )					)
	(incompleteUnary						( black )					)
	(undefinedKeyword						( red )					)
	(undefinedBinary 						( red )					)
	(undefinedUnary						( red )					)													
	(patternKeyword 						( black ) bold				)
	(patternBinary 							( black ) bold				)
	(patternUnary							( black ) bold				)
	(#self 									( cyan muchDarker )	bold	)
	(#super									( cyan muchDarker )	bold	)
	(#true 									( cyan muchDarker )	bold	)
	(#false 									( cyan muchDarker )	bold	)
	(#nil 									( cyan muchDarker )	bold	)
	(#thisContext 							( cyan muchDarker )	bold	)
	(#return								( black )	bold				)
	(patternArg 							( blue muchDarker ) 		)	
	(methodArg 								( blue muchDarker ) 		)		
	(blockPatternArg 						( yellow muchDarker ) 		)		
	(blockArg 								( yellow muchDarker ) 		)	
	(argument 								( blue muchDarker ) 		)		
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						black		) 
	(rightParenthesis1						black		) 
	(leftParenthesis2						black		)  
	(rightParenthesis2						black		)  
	(leftParenthesis3						black		) 
	(rightParenthesis3						black		) 
	(leftParenthesis4						black		) 
	(rightParenthesis4						black		) 
	(leftParenthesis5						black		)  
	(rightParenthesis5						black		) 
	(leftParenthesis6						black		) 
	(rightParenthesis6						black		) 
	(leftParenthesis7						black		) 
	(rightParenthesis7						black		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								black		) 
	(blockEnd1								black		) 
	(blockStart2								black		) 
	(blockEnd2								black		) 
	(blockStart3								black		) 
	(blockEnd3								black		) 
	(blockStart4								black		) 
	(blockEnd4								black		) 
	(blockStart5								black		) 
	(blockEnd5								black		) 
	(blockStart6								black		) 
	(blockEnd6								black		) 
	(blockStart7								black		) 
	(blockEnd7								black		) 																																																
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(byteArrayStart								black		) 
	(byteArrayEnd								black		) 
	(byteArrayStart1							black		) 
	(byteArrayEnd1								black		) 
	(leftBrace 								black		) 
	(rightBrace 								black		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black		) 
	(primitiveOrExternalCallEnd				black		)
	(methodTempBar							black		) 
	(blockTempBar 							black		) 
	(blockArgsBar							black		) 
	(primitive								gray		)
	(externalFunctionCallingConvention		gray		)
	(module									gray		)
	(blockTempVar 							( gray darker ) 		)	
	(blockPatternTempVar					( gray darker ) 		)	
	(instVar 								( blue muchDarker ) 		)	
	(workspaceVar							( blue muchDarker ) 		)	
	(undefinedIdentifier						( red ) 		)	
	(incompleteIdentifier					( blue muchDarker ) 		)	
	(tempVar								( gray darker ) 		)	
	(patternTempVar						( gray darker ) 		)	
	(poolConstant							( blue muchDarker ) 		)	
	(classVar								( blue muchDarker ) 	bold	)	
	(globalVar								( blue muchDarker ) 	bold	) )
							! !

!AMMTextStyler class methodsFor: 'styling' stamp: 'sw 6/1/2013 10:49:11.131'!
styleExpression: aString

	^ self new styleExpression: aString! !

!AMMTextStyler class methodsFor: 'style table' stamp: 'sw 6/1/2013 10:49:11.125'!
subduedStyleTable

	^ self defaultStyleTable! !

!AMMTextStyler methodsFor: 'private' stamp: 'sw 6/1/2013 14:25:27.904'!
attributesFor: aSymbol

	^ (((super attributesFor: aSymbol) ifNil: [#()]), 
		(self customTextAttributes at: aSymbol ifAbsent: [#()])) ifEmpty: []! !

!AMMTextStyler methodsFor: 'accessing' stamp: 'sw 6/1/2013 10:49:11.09'!
customTextAttributes

	^ customTextAttributes ifNil: [customTextAttributes := IdentityDictionary new].! !

!AMMTextStyler methodsFor: 'styling' stamp: 'sw 6/1/2013 10:49:11.098'!
styleExpression: aString
	"Convertes the given expression into a styled text."
	
	| result |
	result := aString asText copy.
	self privateStyle: result.
	^ result! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:16:13.633'!
at: key put: anObject 
	(self includesKey: key) 
		ifFalse: [
		self orderedKeys add: key.
		].
	super at: key put: anObject.
	! !

!OrderedKeysIdentityDictionary methodsFor: '*AMMStudio' stamp: 'sw 5/9/2013 13:17:21.275'!
removeKey: key 

	self orderedKeys remove: key.
	^ super removeKey: key.	
! !

UiTextMorph subclass: #AMMSourceCodeTextMorph
	instanceVariableNames: 'returnCount previousTextEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Widgets'!

!AMMSourceCodeTextMorph methodsFor: 'private' stamp: 'sw 6/1/2013 10:53:14.215'!
editorClass

	^ AMMSourceCodeEditor
! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.114'!
explorerRequested: anObject

	self emitInOwnerChain.! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/2/2013 20:52:37.453'!
expressionEvaluated: result

	^ self emitInOwnerChain! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.13'!
implementorsRequested: aSelector

	self emitInOwnerChain.! !

!AMMSourceCodeTextMorph methodsFor: 'initialization' stamp: 'sw 6/1/2013 10:47:13.159'!
initialize

	super initialize.
	returnCount := 0.
	previousTextEnd := 0.! !

!AMMSourceCodeTextMorph methodsFor: 'event handling' stamp: 'sw 6/1/2013 10:47:13.166'!
keyStroke: aKeyboardEvent

	returnCount == 0 ifTrue: [previousTextEnd := text size + 1].

	super keyStroke: aKeyboardEvent.
	
	self readOnly ifTrue: [^ self].
	
	(({Character lf. Character cr. Character enter} includes: aKeyboardEvent keyCharacter)
		and: [self editor startIndex == (text size + 1)])
		ifTrue: [returnCount := returnCount + 1]
		ifFalse: [returnCount := 0].
		
	returnCount >= 2
		ifTrue: [self repeatedReturnPressed: returnCount].! !

!AMMSourceCodeTextMorph methodsFor: 'event handling' stamp: 'sw 6/1/2013 10:47:13.18'!
mouseUp: evt

	super mouseUp: evt.
	
	self showContextMenu: evt.! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.138'!
queryRequested: anObject

	self emitInOwnerChain.  ! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.145'!
repeatedReturnPressed: count

	self emit.! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.188'!
requestExplorer: anObject

	self explorerRequested: anObject.  ! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.195'!
requestImplementors: aLiteral

	self implementorsRequested: aLiteral.  ! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.202'!
requestQuery: anObject

	self queryRequested: anObject.! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.209'!
requestSenders: aLiteral

	self sendersRequested: aLiteral.  ! !

!AMMSourceCodeTextMorph methodsFor: 'signals' stamp: 'sw 6/1/2013 10:47:13.152'!
sendersRequested: aSelector

	self emitInOwnerChain.! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.216'!
showContextMenu: aMouseEvent

	| menu |
	self selection ifEmpty: [^ self].
	
	menu := ViContextMenu new.
	
	"Connect back to editor to make source code more readable."
	menu
		addIcon: UiFugueIcons folderOpenDocumentTextIcon text: 'Open it (CMD+O)' receiver: self editor selector: #openIt;
		addSeparator;
		addIcon: UiSilkIcons cogIcon text: 'Do it (CMD+D)' receiver: self editor selector: #doIt;
		addIcon: UiSilkIcons printerIcon text: 'Print it (CMD+P)' receiver: self editor selector: #doIt;
		addIcon: UiFugueIcons magnifierIcon text: 'Explore it (CMD+I)' receiver: self editor selector: #exploreIt;
		addIcon: UiFugueIcons documentTreeIcon text: 'Browse it (CMD+B)' receiver: self editor selector: #browseIt;
		addSeparator;
		addIcon: UiFugueIcons arrowStepIcon text: 'Senders of it (CMD+N)' receiver: self editor selector: #sendersOfIt;
		addIcon: UiFugueIcons scriptsTextIcon text: 'Implementors of it (CMD+M)' receiver: self editor selector: #implementorsOfIt.
	
	menu popUpAt: (self pointInWorld: aMouseEvent position).! !

!AMMSourceCodeTextMorph methodsFor: 'actions' stamp: 'sw 6/1/2013 10:47:13.229'!
undoRepeatedReturnPress

	returnCount := 0.
	self selectionChanged.
	self editor backTo: previousTextEnd.
	self updateFromParagraph.! !

UiTextMorph subclass: #AMMTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMTextMorph methodsFor: 'as yet unclassified' stamp: 'sw 5/24/2013 10:45:40.6'!
editorClass

	^ AMMTextEditor! !

TestCase subclass: #AMMApplicationTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/6/2013 13:45:59.44'!
setUp 

	sut := AMMApplication new.
	sut heap: AMMHeap new.
	sut heap objects: sut metaObjects.! !

!AMMApplicationTest methodsFor: 'as yet unclassified' stamp: 'sw 6/6/2013 13:47:38.746'!
testAddObjectAddsObjectsRecursive
	
	| advObj simObj |
	self assert: sut metaObjects isEmpty.
	
	advObj :=AMMMetaObjectAdvancedExample new.
	simObj := AMMMetaObjectSimpleExample new.
	
	advObj otherObject: simObj.
	
	sut addObject: advObj.
	
	self assert: ((sut metaObjects indexOf: (AMMMetaObject for: simObj)) > 0 ).! !

TestCase subclass: #AMMGCAlgorithmTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 6/3/2013 20:03:58.867'!
exampleObjects
	
| objA objB objC coll objD |
	objA := AMMMetaObject new size: 8 ; address: 1; yourself.
	objB := AMMMetaObject new size: 20 ; address: 10; yourself.
	objC := AMMMetaObject new size: 5 ; address: 32; yourself.
	objD := AMMMetaObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB; add:objC.	

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:23:53.463'!
exampleObjectsWithOnlyOneChild
	
| objA objB objC coll objD |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 5 ; address: 32; yourself.
	objD := AMMObject new size: 5 ; address: 37; yourself.

	objA isRoot: true.
	
	objA references add: objB.

	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		add: objD;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:09:47.004'!
exampleObjectsWithOrphan
	
| objA objB coll objC |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	objC := AMMObject new size: 20 ; address: 10; yourself.
	
	objA isRoot: true.
	objA references add: objB.
	
	coll := OrderedCollection new
		add: objA; 
		add: objB;
		add: objC;
		
		yourself.



	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:43:45.55'!
exampleObjectsWithTwoRoots
	
| objA objB coll |
	objA := AMMObject new size: 8 ; address: 1; yourself.
	objB := AMMObject new size: 20 ; address: 10; yourself.
	
	objA isRoot: true.
	
	objB isRoot: true.
	
	coll := OrderedCollection new
		add: objA; 
		add: objB;
		yourself.

	^ coll! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/9/2013 12:56:53.589'!
setUp 

	sut := AMMGCAlgorithm new.
	sut objects: self exampleObjects.! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:14:15.315'!
test010EnterChildOfFirstNode

	| objA objB |
	objA := sut nextObject. 
	
	self assert: (objA == (sut objects at:1)).
	self assert: (objA flag = #activeTraversal). " state is changed "
	
	self assert: ((objA references at:1) flag = #new). " state is still active "
	
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	
	self assert: (objB == (objA references at:1)).

	self assert: (objB flag = #activeTraversal).
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:46:30.414'!
test011ReturnToParentNodeAndContinue

	| objA objB objC |
	sut objects: self exampleObjectsWithOnlyOneChild.
	
	objA := sut nextObject. 
	objB := sut nextObject. 
	
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objB flag = #activeTraversal).
	
	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
	self assert: (objA flag = #doneTraversal). " state is left "
	self assert: (objB flag = #doneTraversal). " state is left "! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:07:48.381'!
test020EnterTwoRoots

	| objA objB objC |
	sut objects: self exampleObjectsWithTwoRoots.
	
	objA := sut nextObject. 
	self assert: (objA flag = #activeTraversal). " state is still active "
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).
	self assert: (objB flag = #activeTraversal).

	self assert: (objA flag = #doneTraversal). " state is still active "
	
	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 19:11:06.447'!
test030DoNotVisitOrphanObject

	| objA objB objC |
	sut objects: self exampleObjectsWithOrphan.
	
	objA := sut nextObject. 
	self assert: (objA = (sut objects at:1)).
	
	objB := sut nextObject. 
	self assert: (objB = (sut objects at:2)).

	objC := sut nextObject. 
	
	self assert: (objC = nil).
	
! !

!AMMGCAlgorithmTest methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 15:09:58.91'!
testFirstVisitedObjectGetsEntered

	| obj |
	obj := sut nextObject. 
	
	self assert: (obj == (sut objects at:1)).
	self assert: (obj flag == #activeTraversal).

	" first object is in the stack "
	self assert: ((sut objectStack orderedKeys last) == obj).
	
	" children counter is zero "
	self assert: ((sut objectStack at: obj) == 0).
	! !

TestCase subclass: #AMMMetaObjectReferencesTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectReferencesTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:00.744'!
testNoReferences
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectSimpleExample new.
	self assert: (sup references size ) = 0.
! !

!AMMMetaObjectReferencesTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:34:53.652'!
testWithReferences
	
	| sup advancedObj simpleObj references |
	advancedObj := AMMMetaObjectAdvancedExample new.
	simpleObj := AMMMetaObjectSimpleExample new.
	sup := AMMMetaObject for: advancedObj.
	
	advancedObj otherObject: simpleObj.
	
	references := sup references.
	self assert: ( references size ) = 1.
	
	self assert: (( references at: 1) =  (AMMMetaObject for: simpleObj )).
	! !

!AMMMetaObjectReferencesTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:35:23.328'!
testWithReferencesReturnsMetaObject
	
	| sup advancedObj simpleObj references |
	advancedObj := AMMMetaObjectAdvancedExample new.
	simpleObj := AMMMetaObjectSimpleExample new.
	advancedObj otherObject: simpleObj.
	sup := AMMMetaObject for: advancedObj.
	
	references := sup references.

	self assert: (( references at: 1) =  (AMMMetaObject for: simpleObj )).
	! !

TestCase subclass: #AMMMetaObjectSizeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio-Test'!

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:08.454'!
testClassSize
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectSimpleExample new.
	self assert: (sup sizeOfObject ) = 34.
! !

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:12.68'!
testClassWithReferencesSize
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectAdvancedExample new.
	self assert: (sup sizeOfObject ) = 12.
! !

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:16.883'!
testSuperclassSize
	
	| sup |
	sup := AMMMetaObject for: AMMMetaObjectSimpleSubExample new.
	self assert: (sup sizeOfObject ) = 38.
! !

!AMMMetaObjectSizeTest methodsFor: 'as yet unclassified' stamp: 'sw 6/4/2013 17:28:21.596'!
testUnextendedClassesCannotBeUsedSize
	
	| sup  error |
	[
		sup := AMMMetaObject for: AMMMetaObjectUnextendedExample new.
	] on: Exception do: [:e | error := e ].

	self assert: error notNil.
! !

NCSimulatedAnnealingGraphLayoutAlgorithm subclass: #AMMGraphLayoutAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AMMStudio'!

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.774'!
aeMinEdgeLength
	"sw: I had to change this, hence errors came up, after removing the PasteUpMorph, although the layout algorithm is still active."
	
	"I am an aesthetic that causes edges to be shortened. My magnitude is d^2, where d is the magnitude of the distance between nodes. Since I consider all edges, my time complexity is O(|E|)"

	| retval |
	retval := IdentityDictionary 
				newFrom: (self nodes collect: [:node | node -> (0 @ 0)]).
	self edges do: 
			[:edge | 
			| fromNode toNode delta mag force |
			fromNode := edge startConnection.
			toNode := edge endConnection.
			((fromNode isNil) or: toNode isNil) ifFalse: [
				delta := toNode center - fromNode center.
				delta := delta / scale.
				mag := delta r.
				force := mag * delta.
				retval at: fromNode put: (retval at: fromNode) + force.
				retval at: toNode put: (retval at: toNode) - force].
			].	

   ^self nodes collect: [:ea | retval at: ea]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'sw 5/13/2013 13:33:02.784'!
aeNodeRepulsion
	"I am an aesthetic that attempts to keep nodes apart. My magnitude is 1/d^2, where d is the magnitude of the distance between nodes. Since I consider all node combinations, my time complexity is O(|V|^2)"

	| retval |
	retval := Array new: self nodes size withAll: 0.0 @ 0.0.
	(1 to: self nodes size) combinations: 2
		atATimeDo: 
			[:arr | 
			| ai1 ai2 node otherNode delta mag2 force |
			 "self halt."
			node := self nodes at: (ai1 := arr at: 1).
			otherNode := self nodes at: (ai2 := arr at: 2).
			delta := (node center - otherNode center) asFloatPoint.
			delta := (delta / scale) + 0.001.
			mag2 := delta x * delta x + (delta y * delta y) max: 1.0e-8.
			force := 1.0 / mag2 * delta.
			retval at: ai1 put: (retval at: ai1) + force.
			retval at: ai2 put: (retval at: ai2) - force].
	^retval! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 20:36:29.937'!
layoutMorph: aPasteUpMorph 
	"sdad"
	aPasteUpMorph allConnectedMorphs isEmpty ifFalse: [
		self preArrangeConnectedMorphs: aPasteUpMorph.
		^ super layoutMorph: aPasteUpMorph
		]! !

!AMMGraphLayoutAlgorithm methodsFor: 'as yet unclassified' stamp: 'ci 5/28/2013 21:26:44.329'!
preArrangeConnectedMorphs: aPasteUpMorph
	"ci: a first implementation.
	the algorithm of the future:
		all roots do:
			collect levels and number of nodes on each level.
			maxLevelNodes = maximum number of nodes per level.
			maxWidth = cDistance (class constant) * maxLevelNodes.
			xDistance per level = maxWidth/ levelNodes.
			parameters: offset, return value: new offset
	"
	| tSize node tPosition |
	tSize := aPasteUpMorph objects size.
	(1 to: tSize) do: [:index |
		node := aPasteUpMorph objectNodes at: (aPasteUpMorph objects at:index).
		
		node object isRoot ifFalse:[
			tPosition := (index*(40@0)) + (0@50).
		]ifTrue:[ 
			tPosition := (index*(40@0)) + (0@10). 
		].
		
		node position: tPosition.
	].! !
